;;; -*- Mode: Lisp; Package: STELLA; Syntax: COMMON-LISP; Base: 10 -*-

#|--------------------------------------------------------------------------+
 |                                                                          |
 |  COPYRIGHT (C) UNIVERSITY OF SOUTHERN CALIFORNIA, 1997-2000              | 
 |  University of Southern California, Information Sciences Institute       |
 |  4676 Admiralty Way                                                      |
 |  Marina Del Rey, California 90292                                        |
 |                                                                          |
 |  This software was developed under the terms and conditions of Contract  |
 |  No. N00014-94-C-0245 between the Defense Advanced Research Projects     |
 |  Agency and the University of Southern California, Information Sciences  | 
 |  Institute.  Use and distribution of this software is further subject    |
 |  to the provisions of that contract and any other agreements developed   |
 |  between the user of the software and the University of Southern         |
 |  California, Information Sciences Institute.  It is supplied "AS IS",    |
 |  without any warranties of any kind.  It is furnished only on the basis  |
 |  that any party who receives it indemnifies and holds harmless the       |
 |  parties who furnish and originate it against any claims, demands, or    |
 |  liabilities connected with using it, furnishing it to others or         |
 |  providing it to a third party.  THIS NOTICE MUST NOT BE REMOVED FROM    |
 |  THE SOFTWARE, AND IN THE EVENT THAT THE SOFTWARE IS DIVIDED, IT SHOULD  |
 |  BE ATTACHED TO EVERY PART.                                              |
 |                                                                          |
 +--------------------------------------------------------------------------|#

(CL:IN-PACKAGE "STELLA")

;;; Auxiliary variables:

(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-PLUS NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-ARITHMETIC--> NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-ARITHMETIC-DOCUMENTATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-ARITHMETIC-AXIOMS NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-COMPUTED NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-CONSTRAINT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-PLUS-CONSTRAINT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-CONSTRAINT-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-MINUS NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-MINUS-CONSTRAINT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-TIMES NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-TIMES-CONSTRAINT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-DIVIDE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-DIVIDE-CONSTRAINT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SQUARE-ROOT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SQUARE-ROOT-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-HANDLES-REVERSE-POLARITY NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INEQUALITY NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-ARITHMETIC-<<= NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-ABSTRACT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-THAN NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-EXISTS NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-EVALUATOR NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INEQUALITY-EVALUATOR NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-ARITHMETIC-<<=>> NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SYNONYM NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-+ NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-= NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-* NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-< NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-=< NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-> NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA->= NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-INTERVAL-CACHE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-HOME-CONTEXT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INTERVAL-MEMBER NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-INTEGER-INTERVAL-CACHE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-LOWER-BOUND NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-UPPER-BOUND NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-FLOAT-INTERVAL-CACHE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-STRICT-LOWER-BOUND? NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-STRICT-UPPER-BOUND? NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INTERVAL-CACHE-OF NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-?B NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INTERVAL-CACHE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-HIDDEN-RELATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-INTERVAL-CACHE-OF NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-ARITHMETIC-STELLA-INTEGER NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-INEQUALITY NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-ARITHMETIC-LOGIC-LOGIC-OBJECT NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-ARITHMETIC-PROPAGATE NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-ARITHMETIC-LOWER-BOUND NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-ARITHMETIC-UPPER-BOUND NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-ARITHMETIC-STELLA-NUMBER-WRAPPER NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-ARITHMETIC-TERMINAL-FAILURE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-ARITHMETIC-STELLA-INTEGER-WRAPPER NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-ARITHMETIC-FINAL-SUCCESS NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-ARITHMETIC-FAILURE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-LENGTH NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-THING NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-INTEGER NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-COMPUTATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LENGTH-COMPUTATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-COMPUTATION-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-STARTUP-ARITHMETIC NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-METHOD-STARTUP-CLASSNAME NULL)

;;; Forward declarations:

(CL:DECLAIM
 (CL:SPECIAL *STARTUP-TIME-PHASE* *MODULE* *REVERSEPOLARITY?*
  *TRACED-KEYWORDS* STANDARD-OUTPUT EOL *CONTEXT* TRUE-WRAPPER
  FALSE-WRAPPER))

;;; (DEFUN (ARITHMETIC-EQUAL-TEST BOOLEAN) ...)

(CL:DEFUN /PL-KERNEL-KB/ARITHMETIC-EQUAL-TEST (X Y)
  (CL:LET* ((TEST-VALUE-002 (SAFE-PRIMARY-TYPE X)))
   (CL:COND
    ((SUBTYPE-OF-INTEGER? TEST-VALUE-002)
     (CL:PROGN
      (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE Y)))
       (CL:COND
        ((SUBTYPE-OF-INTEGER? TEST-VALUE-000)
         (CL:PROGN (CL:= (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y))))
        ((SUBTYPE-OF-FLOAT? TEST-VALUE-000)
         (CL:PROGN
          (CL:= (CL:FLOAT (%WRAPPER-VALUE X) 0.0d0) (%WRAPPER-VALUE Y))))
        (CL:T
         (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
          (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" TEST-VALUE-000
           "' is not a valid case option")
          (CL:ERROR
           (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))))))
    ((SUBTYPE-OF-FLOAT? TEST-VALUE-002)
     (CL:PROGN
      (CL:LET* ((TEST-VALUE-001 (SAFE-PRIMARY-TYPE Y)))
       (CL:COND
        ((SUBTYPE-OF-INTEGER? TEST-VALUE-001)
         (CL:PROGN
          (CL:= (%WRAPPER-VALUE X) (CL:FLOAT (%WRAPPER-VALUE Y) 0.0d0))))
        ((SUBTYPE-OF-FLOAT? TEST-VALUE-001)
         (CL:PROGN (CL:= (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y))))
        (CL:T
         (CL:LET* ((STREAM-001 (NEW-OUTPUT-STRING-STREAM)))
          (%%PRINT-STREAM (%NATIVE-STREAM STREAM-001) "`" TEST-VALUE-001
           "' is not a valid case option")
          (CL:ERROR
           (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-001)))))))))
    (CL:T
     (CL:LET* ((STREAM-002 (NEW-OUTPUT-STRING-STREAM)))
      (%%PRINT-STREAM (%NATIVE-STREAM STREAM-002) "`" TEST-VALUE-002
       "' is not a valid case option")
      (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-002))))))))

;;; (DEFUN (ARITHMETIC-LESS-TEST BOOLEAN) ...)

(CL:DEFUN /PL-KERNEL-KB/ARITHMETIC-LESS-TEST (X Y)
  (CL:LET* ((TEST-VALUE-002 (SAFE-PRIMARY-TYPE X)))
   (CL:COND
    ((SUBTYPE-OF-INTEGER? TEST-VALUE-002)
     (CL:PROGN
      (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE Y)))
       (CL:COND
        ((SUBTYPE-OF-INTEGER? TEST-VALUE-000)
         (CL:PROGN (< (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y))))
        ((SUBTYPE-OF-FLOAT? TEST-VALUE-000)
         (CL:PROGN
          (< (CL:FLOAT (%WRAPPER-VALUE X) 0.0d0) (%WRAPPER-VALUE Y))))
        (CL:T
         (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
          (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" TEST-VALUE-000
           "' is not a valid case option")
          (CL:ERROR
           (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))))))
    ((SUBTYPE-OF-FLOAT? TEST-VALUE-002)
     (CL:PROGN
      (CL:LET* ((TEST-VALUE-001 (SAFE-PRIMARY-TYPE Y)))
       (CL:COND
        ((SUBTYPE-OF-INTEGER? TEST-VALUE-001)
         (CL:PROGN
          (< (%WRAPPER-VALUE X) (CL:FLOAT (%WRAPPER-VALUE Y) 0.0d0))))
        ((SUBTYPE-OF-FLOAT? TEST-VALUE-001)
         (CL:PROGN (< (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y))))
        (CL:T
         (CL:LET* ((STREAM-001 (NEW-OUTPUT-STRING-STREAM)))
          (%%PRINT-STREAM (%NATIVE-STREAM STREAM-001) "`" TEST-VALUE-001
           "' is not a valid case option")
          (CL:ERROR
           (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-001)))))))))
    (CL:T
     (CL:LET* ((STREAM-002 (NEW-OUTPUT-STRING-STREAM)))
      (%%PRINT-STREAM (%NATIVE-STREAM STREAM-002) "`" TEST-VALUE-002
       "' is not a valid case option")
      (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-002))))))))

;;; (DEFUN (ARITHMETIC-GREATER-TEST BOOLEAN) ...)

(CL:DEFUN /PL-KERNEL-KB/ARITHMETIC-GREATER-TEST (X Y)
  (CL:LET* ((TEST-VALUE-002 (SAFE-PRIMARY-TYPE X)))
   (CL:COND
    ((SUBTYPE-OF-INTEGER? TEST-VALUE-002)
     (CL:PROGN
      (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE Y)))
       (CL:COND
        ((SUBTYPE-OF-INTEGER? TEST-VALUE-000)
         (CL:PROGN (> (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y))))
        ((SUBTYPE-OF-FLOAT? TEST-VALUE-000)
         (CL:PROGN
          (> (CL:FLOAT (%WRAPPER-VALUE X) 0.0d0) (%WRAPPER-VALUE Y))))
        (CL:T
         (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
          (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" TEST-VALUE-000
           "' is not a valid case option")
          (CL:ERROR
           (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))))))
    ((SUBTYPE-OF-FLOAT? TEST-VALUE-002)
     (CL:PROGN
      (CL:LET* ((TEST-VALUE-001 (SAFE-PRIMARY-TYPE Y)))
       (CL:COND
        ((SUBTYPE-OF-INTEGER? TEST-VALUE-001)
         (CL:PROGN
          (> (%WRAPPER-VALUE X) (CL:FLOAT (%WRAPPER-VALUE Y) 0.0d0))))
        ((SUBTYPE-OF-FLOAT? TEST-VALUE-001)
         (CL:PROGN (> (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y))))
        (CL:T
         (CL:LET* ((STREAM-001 (NEW-OUTPUT-STRING-STREAM)))
          (%%PRINT-STREAM (%NATIVE-STREAM STREAM-001) "`" TEST-VALUE-001
           "' is not a valid case option")
          (CL:ERROR
           (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-001)))))))))
    (CL:T
     (CL:LET* ((STREAM-002 (NEW-OUTPUT-STRING-STREAM)))
      (%%PRINT-STREAM (%NATIVE-STREAM STREAM-002) "`" TEST-VALUE-002
       "' is not a valid case option")
      (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-002))))))))

;;; (DEFUN (PLUS-COMPUTATION NUMBER-WRAPPER) ...)

(CL:DEFUN /PL-KERNEL-KB/PLUS-COMPUTATION (X Y)
  (CL:LET* ((FLOATRESULT NULL-FLOAT))
   (CL:DECLARE (CL:TYPE CL:DOUBLE-FLOAT FLOATRESULT))
   (CL:LET* ((TEST-VALUE-002 (SAFE-PRIMARY-TYPE X)))
    (CL:COND
     ((SUBTYPE-OF-INTEGER? TEST-VALUE-002)
      (CL:PROGN
       (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE Y)))
        (CL:COND
         ((SUBTYPE-OF-INTEGER? TEST-VALUE-000)
          (CL:PROGN
           (CL:RETURN-FROM /PL-KERNEL-KB/PLUS-COMPUTATION
            (WRAP-INTEGER
             (CL:TRUNCATE
              (CL:+ (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y)))))))
         ((SUBTYPE-OF-FLOAT? TEST-VALUE-000)
          (CL:PROGN
           (CL:SETQ FLOATRESULT
            (CL:+ (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y)))))
         (CL:T
          (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
           (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" TEST-VALUE-000
            "' is not a valid case option")
           (CL:ERROR
            (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))))))
     ((SUBTYPE-OF-FLOAT? TEST-VALUE-002)
      (CL:PROGN
       (CL:LET* ((TEST-VALUE-001 (SAFE-PRIMARY-TYPE Y)))
        (CL:COND
         ((SUBTYPE-OF-INTEGER? TEST-VALUE-001)
          (CL:PROGN
           (CL:SETQ FLOATRESULT
            (CL:+ (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y)))))
         ((SUBTYPE-OF-FLOAT? TEST-VALUE-001)
          (CL:PROGN
           (CL:SETQ FLOATRESULT
            (CL:+ (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y)))))
         (CL:T
          (CL:LET* ((STREAM-001 (NEW-OUTPUT-STRING-STREAM)))
           (%%PRINT-STREAM (%NATIVE-STREAM STREAM-001) "`" TEST-VALUE-001
            "' is not a valid case option")
           (CL:ERROR
            (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-001)))))))))
     (CL:T
      (CL:LET* ((STREAM-002 (NEW-OUTPUT-STRING-STREAM)))
       (%%PRINT-STREAM (%NATIVE-STREAM STREAM-002) "`" TEST-VALUE-002
        "' is not a valid case option")
       (CL:ERROR
        (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-002)))))))
   (WRAP-FLOAT FLOATRESULT)))

;;; (DEFUN (MINUS-COMPUTATION NUMBER-WRAPPER) ...)

(CL:DEFUN /PL-KERNEL-KB/MINUS-COMPUTATION (X Y)
  (CL:LET* ((FLOATRESULT NULL-FLOAT))
   (CL:DECLARE (CL:TYPE CL:DOUBLE-FLOAT FLOATRESULT))
   (CL:LET* ((TEST-VALUE-002 (SAFE-PRIMARY-TYPE X)))
    (CL:COND
     ((SUBTYPE-OF-INTEGER? TEST-VALUE-002)
      (CL:PROGN
       (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE Y)))
        (CL:COND
         ((SUBTYPE-OF-INTEGER? TEST-VALUE-000)
          (CL:PROGN
           (CL:RETURN-FROM /PL-KERNEL-KB/MINUS-COMPUTATION
            (WRAP-INTEGER
             (CL:TRUNCATE
              (CL:- (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y)))))))
         ((SUBTYPE-OF-FLOAT? TEST-VALUE-000)
          (CL:PROGN
           (CL:SETQ FLOATRESULT
            (CL:- (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y)))))
         (CL:T
          (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
           (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" TEST-VALUE-000
            "' is not a valid case option")
           (CL:ERROR
            (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))))))
     ((SUBTYPE-OF-FLOAT? TEST-VALUE-002)
      (CL:PROGN
       (CL:LET* ((TEST-VALUE-001 (SAFE-PRIMARY-TYPE Y)))
        (CL:COND
         ((SUBTYPE-OF-INTEGER? TEST-VALUE-001)
          (CL:PROGN
           (CL:SETQ FLOATRESULT
            (CL:- (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y)))))
         ((SUBTYPE-OF-FLOAT? TEST-VALUE-001)
          (CL:PROGN
           (CL:SETQ FLOATRESULT
            (CL:- (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y)))))
         (CL:T
          (CL:LET* ((STREAM-001 (NEW-OUTPUT-STRING-STREAM)))
           (%%PRINT-STREAM (%NATIVE-STREAM STREAM-001) "`" TEST-VALUE-001
            "' is not a valid case option")
           (CL:ERROR
            (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-001)))))))))
     (CL:T
      (CL:LET* ((STREAM-002 (NEW-OUTPUT-STRING-STREAM)))
       (%%PRINT-STREAM (%NATIVE-STREAM STREAM-002) "`" TEST-VALUE-002
        "' is not a valid case option")
       (CL:ERROR
        (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-002)))))))
   (WRAP-FLOAT FLOATRESULT)))

;;; (DEFUN (TIMES-COMPUTATION NUMBER-WRAPPER) ...)

(CL:DEFUN /PL-KERNEL-KB/TIMES-COMPUTATION (X Y)
  (CL:LET* ((FLOATRESULT NULL-FLOAT))
   (CL:DECLARE (CL:TYPE CL:DOUBLE-FLOAT FLOATRESULT))
   (CL:LET* ((TEST-VALUE-002 (SAFE-PRIMARY-TYPE X)))
    (CL:COND
     ((SUBTYPE-OF-INTEGER? TEST-VALUE-002)
      (CL:PROGN
       (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE Y)))
        (CL:COND
         ((SUBTYPE-OF-INTEGER? TEST-VALUE-000)
          (CL:PROGN
           (CL:RETURN-FROM /PL-KERNEL-KB/TIMES-COMPUTATION
            (WRAP-INTEGER
             (CL:TRUNCATE
              (CL:* (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y)))))))
         ((SUBTYPE-OF-FLOAT? TEST-VALUE-000)
          (CL:PROGN
           (CL:SETQ FLOATRESULT
            (CL:* (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y)))))
         (CL:T
          (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
           (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" TEST-VALUE-000
            "' is not a valid case option")
           (CL:ERROR
            (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))))))
     ((SUBTYPE-OF-FLOAT? TEST-VALUE-002)
      (CL:PROGN
       (CL:LET* ((TEST-VALUE-001 (SAFE-PRIMARY-TYPE Y)))
        (CL:COND
         ((SUBTYPE-OF-INTEGER? TEST-VALUE-001)
          (CL:PROGN
           (CL:SETQ FLOATRESULT
            (CL:* (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y)))))
         ((SUBTYPE-OF-FLOAT? TEST-VALUE-001)
          (CL:PROGN
           (CL:SETQ FLOATRESULT
            (CL:* (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y)))))
         (CL:T
          (CL:LET* ((STREAM-001 (NEW-OUTPUT-STRING-STREAM)))
           (%%PRINT-STREAM (%NATIVE-STREAM STREAM-001) "`" TEST-VALUE-001
            "' is not a valid case option")
           (CL:ERROR
            (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-001)))))))))
     (CL:T
      (CL:LET* ((STREAM-002 (NEW-OUTPUT-STRING-STREAM)))
       (%%PRINT-STREAM (%NATIVE-STREAM STREAM-002) "`" TEST-VALUE-002
        "' is not a valid case option")
       (CL:ERROR
        (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-002)))))))
   (WRAP-FLOAT FLOATRESULT)))

;;; (DEFUN (DIVIDE-COMPUTATION NUMBER-WRAPPER) ...)

(CL:DEFUN /PL-KERNEL-KB/DIVIDE-COMPUTATION (X Y)
  (CL:LET* ((FLOATRESULT NULL-FLOAT))
   (CL:DECLARE (CL:TYPE CL:DOUBLE-FLOAT FLOATRESULT))
   (CL:LET* ((TEST-VALUE-002 (SAFE-PRIMARY-TYPE X)))
    (CL:COND
     ((SUBTYPE-OF-INTEGER? TEST-VALUE-002)
      (CL:PROGN
       (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE Y)))
        (CL:COND
         ((SUBTYPE-OF-INTEGER? TEST-VALUE-000)
          (CL:PROGN
           (CL:IF
            (CL:=
             (CL:THE CL:FIXNUM
              (CL:MOD (CL:THE CL:FIXNUM (%WRAPPER-VALUE X))
               (CL:THE CL:FIXNUM (%WRAPPER-VALUE Y))))
             0)
            (CL:RETURN-FROM /PL-KERNEL-KB/DIVIDE-COMPUTATION
             (WRAP-INTEGER
              (CL:TRUNCATE
               (CL:/ (CL:FLOAT (%WRAPPER-VALUE X) 0.0d0)
                (%WRAPPER-VALUE Y)))))
            (CL:SETQ FLOATRESULT
             (CL:/ (CL:FLOAT (%WRAPPER-VALUE X) 0.0d0)
              (CL:FLOAT (%WRAPPER-VALUE Y) 0.0d0))))))
         ((SUBTYPE-OF-FLOAT? TEST-VALUE-000)
          (CL:PROGN
           (CL:SETQ FLOATRESULT
            (CL:/ (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y)))))
         (CL:T
          (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
           (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" TEST-VALUE-000
            "' is not a valid case option")
           (CL:ERROR
            (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))))))
     ((SUBTYPE-OF-FLOAT? TEST-VALUE-002)
      (CL:PROGN
       (CL:LET* ((TEST-VALUE-001 (SAFE-PRIMARY-TYPE Y)))
        (CL:COND
         ((SUBTYPE-OF-INTEGER? TEST-VALUE-001)
          (CL:PROGN
           (CL:SETQ FLOATRESULT
            (CL:/ (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y)))))
         ((SUBTYPE-OF-FLOAT? TEST-VALUE-001)
          (CL:PROGN
           (CL:SETQ FLOATRESULT
            (CL:/ (%WRAPPER-VALUE X) (%WRAPPER-VALUE Y)))))
         (CL:T
          (CL:LET* ((STREAM-001 (NEW-OUTPUT-STRING-STREAM)))
           (%%PRINT-STREAM (%NATIVE-STREAM STREAM-001) "`" TEST-VALUE-001
            "' is not a valid case option")
           (CL:ERROR
            (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-001)))))))))
     (CL:T
      (CL:LET* ((STREAM-002 (NEW-OUTPUT-STRING-STREAM)))
       (%%PRINT-STREAM (%NATIVE-STREAM STREAM-002) "`" TEST-VALUE-002
        "' is not a valid case option")
       (CL:ERROR
        (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-002)))))))
   (WRAP-FLOAT FLOATRESULT)))

;;; (DEFUN (SQRT-COMPUTATION NUMBER-WRAPPER) ...)

(CL:DEFUN /PL-KERNEL-KB/SQRT-COMPUTATION (X)
  (CL:LET* ((FLOATRESULT NULL-FLOAT) (INTEGERRESULT NULL-INTEGER))
   (CL:DECLARE (CL:TYPE CL:DOUBLE-FLOAT FLOATRESULT)
    (CL:TYPE CL:FIXNUM INTEGERRESULT))
   (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE X)))
    (CL:COND
     ((SUBTYPE-OF-INTEGER? TEST-VALUE-000)
      (CL:PROGN
       (CL:SETQ FLOATRESULT
        (CL:THE CL:DOUBLE-FLOAT
         (CL:SQRT
          (CL:THE CL:DOUBLE-FLOAT (CL:FLOAT (%WRAPPER-VALUE X) 0.0d0)))))
       (CL:SETQ INTEGERRESULT (CL:TRUNCATE FLOATRESULT))
       (CL:IF (CL:= FLOATRESULT (CL:FLOAT INTEGERRESULT 0.0d0))
        (CL:RETURN-FROM /PL-KERNEL-KB/SQRT-COMPUTATION
         (WRAP-INTEGER INTEGERRESULT))
        (CL:RETURN-FROM /PL-KERNEL-KB/SQRT-COMPUTATION
         (WRAP-FLOAT FLOATRESULT)))))
     ((SUBTYPE-OF-FLOAT? TEST-VALUE-000)
      (CL:PROGN
       (CL:SETQ FLOATRESULT
        (CL:THE CL:DOUBLE-FLOAT
         (CL:SQRT (CL:THE CL:DOUBLE-FLOAT (%WRAPPER-VALUE X)))))))
     (CL:T
      (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
       (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" TEST-VALUE-000
        "' is not a valid case option")
       (CL:ERROR
        (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))))
   (WRAP-FLOAT FLOATRESULT)))

;;; (DEFUN (PLUS-CONSTRAINT OBJECT) ...)

(CL:DEFUN /PL-KERNEL-KB/PLUS-CONSTRAINT (MISSING-ARGUMENT X1 X2 X3)
  (CL:LET* ((VALUE NULL))
   (CL:CASE (%WRAPPER-VALUE MISSING-ARGUMENT)
    (-1
     (CL:SETQ VALUE
      (CL:IF
       (/PL-KERNEL-KB/ARITHMETIC-EQUAL-TEST
        (/PL-KERNEL-KB/PLUS-COMPUTATION X1 X2) X3)
       TRUE-WRAPPER FALSE-WRAPPER)))
    (0 (CL:SETQ VALUE (/PL-KERNEL-KB/MINUS-COMPUTATION X3 X2)))
    (1 (CL:SETQ VALUE (/PL-KERNEL-KB/MINUS-COMPUTATION X3 X1)))
    (2 (CL:SETQ VALUE (/PL-KERNEL-KB/PLUS-COMPUTATION X1 X2)))
    (CL:OTHERWISE))
   VALUE))

;;; (DEFUN (MINUS-CONSTRAINT OBJECT) ...)

(CL:DEFUN /PL-KERNEL-KB/MINUS-CONSTRAINT (MISSING-ARGUMENT X1 X2 X3)
  (CL:LET* ((VALUE NULL))
   (CL:CASE (%WRAPPER-VALUE MISSING-ARGUMENT)
    (-1
     (CL:SETQ VALUE
      (CL:IF
       (/PL-KERNEL-KB/ARITHMETIC-EQUAL-TEST
        (/PL-KERNEL-KB/MINUS-COMPUTATION X1 X2) X3)
       TRUE-WRAPPER FALSE-WRAPPER)))
    (0 (CL:SETQ VALUE (/PL-KERNEL-KB/PLUS-COMPUTATION X2 X3)))
    (1 (CL:SETQ VALUE (/PL-KERNEL-KB/MINUS-COMPUTATION X1 X3)))
    (2 (CL:SETQ VALUE (/PL-KERNEL-KB/MINUS-COMPUTATION X1 X2)))
    (CL:OTHERWISE))
   VALUE))

;;; (DEFUN (TIMES-CONSTRAINT OBJECT) ...)

(CL:DEFUN /PL-KERNEL-KB/TIMES-CONSTRAINT (MISSING-ARGUMENT X1 X2 X3)
  (CL:LET* ((VALUE NULL))
   (CL:CASE (%WRAPPER-VALUE MISSING-ARGUMENT)
    (-1
     (CL:SETQ VALUE
      (CL:IF
       (/PL-KERNEL-KB/ARITHMETIC-EQUAL-TEST
        (/PL-KERNEL-KB/TIMES-COMPUTATION X1 X2) X3)
       TRUE-WRAPPER FALSE-WRAPPER)))
    (0 (CL:SETQ VALUE (/PL-KERNEL-KB/DIVIDE-COMPUTATION X3 X2)))
    (1 (CL:SETQ VALUE (/PL-KERNEL-KB/DIVIDE-COMPUTATION X3 X1)))
    (2 (CL:SETQ VALUE (/PL-KERNEL-KB/TIMES-COMPUTATION X1 X2)))
    (CL:OTHERWISE))
   VALUE))

;;; (DEFUN (DIVIDE-CONSTRAINT OBJECT) ...)

(CL:DEFUN /PL-KERNEL-KB/DIVIDE-CONSTRAINT (MISSING-ARGUMENT X1 X2 X3)
  (CL:LET* ((VALUE NULL))
   (CL:CASE (%WRAPPER-VALUE MISSING-ARGUMENT)
    (-1
     (CL:SETQ VALUE
      (CL:IF
       (/PL-KERNEL-KB/ARITHMETIC-EQUAL-TEST
        (/PL-KERNEL-KB/TIMES-COMPUTATION X2 X3) X1)
       TRUE-WRAPPER FALSE-WRAPPER)))
    (0 (CL:SETQ VALUE (/PL-KERNEL-KB/TIMES-COMPUTATION X2 X3)))
    (1 (CL:SETQ VALUE (/PL-KERNEL-KB/DIVIDE-COMPUTATION X1 X3)))
    (2 (CL:SETQ VALUE (/PL-KERNEL-KB/DIVIDE-COMPUTATION X1 X2)))
    (CL:OTHERWISE))
   VALUE))

;;; (DEFUN (SQRT-CONSTRAINT OBJECT) ...)

(CL:DEFUN /PL-KERNEL-KB/SQRT-CONSTRAINT (MISSING-ARGUMENT X1 X2)
  (CL:LET* ((VALUE NULL))
   (CL:CASE (%WRAPPER-VALUE MISSING-ARGUMENT)
    (-1
     (CL:SETQ VALUE
      (CL:IF
       (/PL-KERNEL-KB/ARITHMETIC-EQUAL-TEST
        (/PL-KERNEL-KB/TIMES-COMPUTATION X2 X2) X1)
       TRUE-WRAPPER FALSE-WRAPPER)))
    (0 (CL:SETQ VALUE (/PL-KERNEL-KB/TIMES-COMPUTATION X2 X2)))
    (1
     (CL:IF (/PL-KERNEL-KB/ARITHMETIC-LESS-TEST X1 (WRAP-INTEGER 0))
      (CL:SETQ VALUE NULL)
      (CL:SETQ VALUE (/PL-KERNEL-KB/SQRT-COMPUTATION X1))))
    (CL:OTHERWISE))
   VALUE))

;;; (DEFCLASS INTERVAL-CACHE ...)

(CL:DEFCLASS /PL-KERNEL-KB/INTERVAL-CACHE (THING)
  ((HOME-CONTEXT :ALLOCATION :INSTANCE :ACCESSOR %HOME-CONTEXT)
   (/PL-KERNEL-KB/INTERVAL-MEMBER :ALLOCATION :INSTANCE :ACCESSOR
    /PL-KERNEL-KB/%INTERVAL-MEMBER)))

(CL:DEFUN /PL-KERNEL-KB/NEW-INTERVAL-CACHE ()
  (CL:LET* ((SELF NULL))
   (CL:SETQ SELF
    (CL:MAKE-INSTANCE (CL:QUOTE /PL-KERNEL-KB/INTERVAL-CACHE)))
   (CL:SETF (%DYNAMIC-SLOTS SELF) (NEW-KEY-VALUE-LIST))
   (CL:SETF (%SURROGATE-VALUE-INVERSE SELF) NULL)
   (CL:SETF (/PL-KERNEL-KB/%INTERVAL-MEMBER SELF) NULL)
   (CL:SETF (%HOME-CONTEXT SELF) NULL) SELF))

(CL:DEFMETHOD PRIMARY-TYPE ((SELF /PL-KERNEL-KB/INTERVAL-CACHE))
  /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-INTERVAL-CACHE)

(CL:DEFUN /PL-KERNEL-KB/ACCESS-INTERVAL-CACHE-SLOT-VALUE (SELF SLOTNAME VALUE SETVALUE?)
  (CL:COND
   ((CL:EQ SLOTNAME /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-HOME-CONTEXT)
    (CL:IF SETVALUE? (CL:SETF (%HOME-CONTEXT SELF) VALUE)
     (CL:SETQ VALUE (%HOME-CONTEXT SELF))))
   ((CL:EQ SLOTNAME
     /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INTERVAL-MEMBER)
    (CL:IF SETVALUE? (CL:SETF (/PL-KERNEL-KB/%INTERVAL-MEMBER SELF) VALUE)
     (CL:SETQ VALUE (/PL-KERNEL-KB/%INTERVAL-MEMBER SELF))))
   (CL:T
    (CL:IF SETVALUE?
     (SET-DYNAMIC-SLOT-VALUE (%DYNAMIC-SLOTS SELF) SLOTNAME VALUE NULL)
     (CL:SETQ VALUE (LOOKUP (%DYNAMIC-SLOTS SELF) SLOTNAME)))))
  VALUE)

;;; (DEFCLASS INTEGER-INTERVAL-CACHE ...)

(CL:DEFCLASS /PL-KERNEL-KB/INTEGER-INTERVAL-CACHE (/PL-KERNEL-KB/INTERVAL-CACHE)
  ((LOWER-BOUND :ALLOCATION :INSTANCE :ACCESSOR %LOWER-BOUND)
   (UPPER-BOUND :ALLOCATION :INSTANCE :ACCESSOR %UPPER-BOUND)))

(CL:DEFUN /PL-KERNEL-KB/NEW-INTEGER-INTERVAL-CACHE ()
  (CL:LET* ((SELF NULL))
   (CL:SETQ SELF
    (CL:MAKE-INSTANCE (CL:QUOTE /PL-KERNEL-KB/INTEGER-INTERVAL-CACHE)))
   (CL:SETF (%DYNAMIC-SLOTS SELF) (NEW-KEY-VALUE-LIST))
   (CL:SETF (%SURROGATE-VALUE-INVERSE SELF) NULL)
   (CL:SETF (/PL-KERNEL-KB/%INTERVAL-MEMBER SELF) NULL)
   (CL:SETF (%HOME-CONTEXT SELF) NULL)
   (CL:SETF (%UPPER-BOUND SELF) NULL-INTEGER)
   (CL:SETF (%LOWER-BOUND SELF) NULL-INTEGER) SELF))

(CL:DEFMETHOD PRIMARY-TYPE ((SELF /PL-KERNEL-KB/INTEGER-INTERVAL-CACHE))
  /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-INTEGER-INTERVAL-CACHE)

(CL:DEFUN /PL-KERNEL-KB/ACCESS-INTEGER-INTERVAL-CACHE-SLOT-VALUE (SELF SLOTNAME VALUE SETVALUE?)
  (CL:COND
   ((CL:EQ SLOTNAME /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-LOWER-BOUND)
    (CL:IF SETVALUE? (CL:SETF (%LOWER-BOUND SELF) (%WRAPPER-VALUE VALUE))
     (CL:SETQ VALUE (WRAP-INTEGER (%LOWER-BOUND SELF)))))
   ((CL:EQ SLOTNAME /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-UPPER-BOUND)
    (CL:IF SETVALUE? (CL:SETF (%UPPER-BOUND SELF) (%WRAPPER-VALUE VALUE))
     (CL:SETQ VALUE (WRAP-INTEGER (%UPPER-BOUND SELF)))))
   (CL:T
    (CL:IF SETVALUE?
     (SET-DYNAMIC-SLOT-VALUE (%DYNAMIC-SLOTS SELF) SLOTNAME VALUE NULL)
     (CL:SETQ VALUE (LOOKUP (%DYNAMIC-SLOTS SELF) SLOTNAME)))))
  VALUE)

(CL:DEFMETHOD PRINT-OBJECT ((SELF /PL-KERNEL-KB/INTEGER-INTERVAL-CACHE) STREAM)
  (%%PRINT-STREAM STREAM "|IIcache-of: "
   (/PL-KERNEL-KB/%INTERVAL-MEMBER SELF) " ["
   (CL:IF (DEFINED? (%LOWER-BOUND SELF))
    (INTEGER-TO-STRING (%LOWER-BOUND SELF)) "?")
   ","
   (CL:IF (DEFINED? (%UPPER-BOUND SELF))
    (INTEGER-TO-STRING (%UPPER-BOUND SELF)) "?")
   "]|"))

;;; (DEFCLASS FLOAT-INTERVAL-CACHE ...)

(CL:DEFCLASS /PL-KERNEL-KB/FLOAT-INTERVAL-CACHE (/PL-KERNEL-KB/INTERVAL-CACHE)
  ((LOWER-BOUND :ALLOCATION :INSTANCE :ACCESSOR %LOWER-BOUND)
   (UPPER-BOUND :ALLOCATION :INSTANCE :ACCESSOR %UPPER-BOUND)
   (/PL-KERNEL-KB/STRICT-LOWER-BOUND? :ALLOCATION :INSTANCE :ACCESSOR
    /PL-KERNEL-KB/%STRICT-LOWER-BOUND?)
   (/PL-KERNEL-KB/STRICT-UPPER-BOUND? :ALLOCATION :INSTANCE :ACCESSOR
    /PL-KERNEL-KB/%STRICT-UPPER-BOUND?)))

(CL:DEFUN /PL-KERNEL-KB/NEW-FLOAT-INTERVAL-CACHE ()
  (CL:LET* ((SELF NULL))
   (CL:SETQ SELF
    (CL:MAKE-INSTANCE (CL:QUOTE /PL-KERNEL-KB/FLOAT-INTERVAL-CACHE)))
   (CL:SETF (%DYNAMIC-SLOTS SELF) (NEW-KEY-VALUE-LIST))
   (CL:SETF (%SURROGATE-VALUE-INVERSE SELF) NULL)
   (CL:SETF (/PL-KERNEL-KB/%INTERVAL-MEMBER SELF) NULL)
   (CL:SETF (%HOME-CONTEXT SELF) NULL)
   (CL:SETF (/PL-KERNEL-KB/%STRICT-UPPER-BOUND? SELF) FALSE)
   (CL:SETF (/PL-KERNEL-KB/%STRICT-LOWER-BOUND? SELF) FALSE)
   (CL:SETF (%UPPER-BOUND SELF) NULL-FLOAT)
   (CL:SETF (%LOWER-BOUND SELF) NULL-FLOAT) SELF))

(CL:DEFMETHOD PRIMARY-TYPE ((SELF /PL-KERNEL-KB/FLOAT-INTERVAL-CACHE))
  /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-FLOAT-INTERVAL-CACHE)

(CL:DEFUN /PL-KERNEL-KB/ACCESS-FLOAT-INTERVAL-CACHE-SLOT-VALUE (SELF SLOTNAME VALUE SETVALUE?)
  (CL:COND
   ((CL:EQ SLOTNAME /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-LOWER-BOUND)
    (CL:IF SETVALUE? (CL:SETF (%LOWER-BOUND SELF) (%WRAPPER-VALUE VALUE))
     (CL:SETQ VALUE (WRAP-FLOAT (%LOWER-BOUND SELF)))))
   ((CL:EQ SLOTNAME /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-UPPER-BOUND)
    (CL:IF SETVALUE? (CL:SETF (%UPPER-BOUND SELF) (%WRAPPER-VALUE VALUE))
     (CL:SETQ VALUE (WRAP-FLOAT (%UPPER-BOUND SELF)))))
   ((CL:EQ SLOTNAME
     /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-STRICT-LOWER-BOUND?)
    (CL:IF SETVALUE?
     (CL:SETF (/PL-KERNEL-KB/%STRICT-LOWER-BOUND? SELF)
      (COERCE-WRAPPED-BOOLEAN-TO-BOOLEAN VALUE))
     (CL:SETQ VALUE
      (CL:IF (/PL-KERNEL-KB/%STRICT-LOWER-BOUND? SELF) TRUE-WRAPPER
       FALSE-WRAPPER))))
   ((CL:EQ SLOTNAME
     /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-STRICT-UPPER-BOUND?)
    (CL:IF SETVALUE?
     (CL:SETF (/PL-KERNEL-KB/%STRICT-UPPER-BOUND? SELF)
      (COERCE-WRAPPED-BOOLEAN-TO-BOOLEAN VALUE))
     (CL:SETQ VALUE
      (CL:IF (/PL-KERNEL-KB/%STRICT-UPPER-BOUND? SELF) TRUE-WRAPPER
       FALSE-WRAPPER))))
   (CL:T
    (CL:IF SETVALUE?
     (SET-DYNAMIC-SLOT-VALUE (%DYNAMIC-SLOTS SELF) SLOTNAME VALUE NULL)
     (CL:SETQ VALUE (LOOKUP (%DYNAMIC-SLOTS SELF) SLOTNAME)))))
  VALUE)

(CL:DEFMETHOD PRINT-OBJECT ((SELF /PL-KERNEL-KB/FLOAT-INTERVAL-CACHE) STREAM)
  (%%PRINT-STREAM STREAM "|FIcache-of: "
   (/PL-KERNEL-KB/%INTERVAL-MEMBER SELF) " "
   (CL:IF (/PL-KERNEL-KB/%STRICT-LOWER-BOUND? SELF) "(" "[")
   (CL:IF (CL:NOT (CL:= (%LOWER-BOUND SELF) NULL-FLOAT))
    (FLOAT-TO-STRING (%LOWER-BOUND SELF)) "?")
   ","
   (CL:IF (CL:NOT (CL:= (%UPPER-BOUND SELF) NULL-FLOAT))
    (FLOAT-TO-STRING (%UPPER-BOUND SELF)) "?")
   (CL:IF (/PL-KERNEL-KB/%STRICT-UPPER-BOUND? SELF) ")" "]") "|"))

;;; (DEFUN (CREATE-INTERVAL-CACHE INTERVAL-CACHE) ...)

(CL:DEFUN /PL-KERNEL-KB/CREATE-INTERVAL-CACHE (INTERVALMEMBER INTEGER?)
  (CL:LET*
   ((INTERVALCACHE
     (CL:IF INTEGER? (/PL-KERNEL-KB/NEW-INTEGER-INTERVAL-CACHE)
      (/PL-KERNEL-KB/NEW-FLOAT-INTERVAL-CACHE))))
   (CL:SETF (/PL-KERNEL-KB/%INTERVAL-MEMBER INTERVALCACHE) INTERVALMEMBER)
   (CL:SETF (%HOME-CONTEXT INTERVALCACHE) *CONTEXT*)
   (ASSERT-BINARY-VALUE
    /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-INTERVAL-CACHE-OF
    INTERVALMEMBER INTERVALCACHE)
   INTERVALCACHE))

;;; (DEFUN (GET-INTERVAL-CACHE INTERVAL-CACHE) ...)

(CL:DEFUN /PL-KERNEL-KB/GET-INTERVAL-CACHE (SELF)
  (CL:LET*
   ((INTERVALCACHE
     (ACCESS-BINARY-VALUE SELF
      /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-INTERVAL-CACHE-OF)))
   (CL:IF
    (CL:AND (CL:NOT (CL:EQ INTERVALCACHE NULL))
     (CL:NOT (SKOLEM? INTERVALCACHE))
     (CL:EQ (%HOME-CONTEXT INTERVALCACHE) *CONTEXT*))
    INTERVALCACHE
    (/PL-KERNEL-KB/CREATE-INTERVAL-CACHE SELF
     (TEST-ISA? SELF /PL-KERNEL-KB/SGT-ARITHMETIC-STELLA-INTEGER)))))

;;; (DEFUN (COERCE-INTERVAL-BOUND-TO-INTEGER INTEGER) ...)

(CL:DEFUN /PL-KERNEL-KB/COERCE-INTERVAL-BOUND-TO-INTEGER (SELF OPERATOR)
  (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE SELF)))
   (CL:COND
    ((SUBTYPE-OF-INTEGER? TEST-VALUE-000)
     (CL:PROGN
      (/PL-KERNEL-KB/INTEGER.COERCE-INTERVAL-BOUND-TO-INTEGER SELF
       OPERATOR)))
    ((SUBTYPE-OF-FLOAT? TEST-VALUE-000)
     (CL:PROGN
      (/PL-KERNEL-KB/FLOAT.COERCE-INTERVAL-BOUND-TO-INTEGER SELF
       OPERATOR)))
    (CL:T
     (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
      (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" TEST-VALUE-000
       "' is not a valid case option")
      (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000))))))))

;;; (DEFUN (INTEGER.COERCE-INTERVAL-BOUND-TO-INTEGER INTEGER) ...)

(CL:DEFUN /PL-KERNEL-KB/INTEGER.COERCE-INTERVAL-BOUND-TO-INTEGER (SELF OPERATOR)
  (CL:WHEN (NULL? (%WRAPPER-VALUE SELF))
   (CL:RETURN-FROM /PL-KERNEL-KB/INTEGER.COERCE-INTERVAL-BOUND-TO-INTEGER
    NULL-INTEGER))
  (CL:COND
   ((CL:EQ OPERATOR
     /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN)
    (CL:1+ (%WRAPPER-VALUE SELF)))
   ((CL:EQ OPERATOR
     /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL)
    (%WRAPPER-VALUE SELF))
   ((CL:EQ OPERATOR /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN)
    (CL:1- (%WRAPPER-VALUE SELF)))
   ((CL:EQ OPERATOR
     /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL)
    (%WRAPPER-VALUE SELF))
   (CL:T
    (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
     (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" OPERATOR
      "' is not a valid case option")
     (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))))

;;; (DEFUN (FLOAT.COERCE-INTERVAL-BOUND-TO-INTEGER INTEGER) ...)

(CL:DEFUN /PL-KERNEL-KB/FLOAT.COERCE-INTERVAL-BOUND-TO-INTEGER (SELF OPERATOR)
  (CL:WHEN (CL:= (%WRAPPER-VALUE SELF) NULL-FLOAT)
   (CL:RETURN-FROM /PL-KERNEL-KB/FLOAT.COERCE-INTERVAL-BOUND-TO-INTEGER
    NULL-INTEGER))
  (CL:COND
   ((CL:EQ OPERATOR
     /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN)
    (CL:1+ (FLOOR (%WRAPPER-VALUE SELF))))
   ((CL:EQ OPERATOR
     /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL)
    (CEILING (%WRAPPER-VALUE SELF)))
   ((CL:EQ OPERATOR /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN)
    (CL:1- (CEILING (%WRAPPER-VALUE SELF))))
   ((CL:EQ OPERATOR
     /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL)
    (FLOOR (%WRAPPER-VALUE SELF)))
   (CL:T
    (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
     (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" OPERATOR
      "' is not a valid case option")
     (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))))

;;; (DEFUN SIGNAL-INTERVAL-CLASH ...)

(CL:DEFUN /PL-KERNEL-KB/SIGNAL-INTERVAL-CLASH (INTERVAL)
  (MARK-AS-INCOHERENT (/PL-KERNEL-KB/%INTERVAL-MEMBER INTERVAL))
  (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
   (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000)
    "Clash in interval values `" INTERVAL "'" EOL)
   (CL:ERROR (NEW-CLASH (THE-STRING-READER STREAM-000)))))

;;; (DEFUN EVALUATE-ADJACENT-INEQUALITIES ...)

(CL:DEFUN /PL-KERNEL-KB/EVALUATE-ADJACENT-INEQUALITIES (SELF)
  (CL:LET*
   ((DEP NULL)
    (ITER-000
     (ALL-SPECIALIZING-DEPENDENT-PROPOSITIONS SELF
      /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-INEQUALITY)))
   (CL:LOOP WHILE (NEXT? ITER-000) DO (CL:SETQ DEP (%VALUE ITER-000))
    (CL:LET* ((ALWAYS?-000 TRUE))
     (CL:LET*
      ((ARG NULL) (VECTOR-000 (%ARGUMENTS DEP)) (INDEX-000 0)
       (LENGTH-000 (LENGTH VECTOR-000)))
      (CL:DECLARE (CL:TYPE CL:FIXNUM INDEX-000 LENGTH-000))
      (CL:LOOP WHILE (CL:< INDEX-000 LENGTH-000) DO
       (CL:PROGN
        (CL:SETQ ARG
         (CL:AREF (CL:THE CL:SIMPLE-VECTOR (%THE-ARRAY VECTOR-000))
          INDEX-000))
        (CL:SETQ INDEX-000 (CL:1+ INDEX-000)))
       (CL:WHEN
        (CL:NOT
         (CL:OR
          (ISA? (VALUE-OF ARG)
           /PL-KERNEL-KB/SGT-ARITHMETIC-LOGIC-LOGIC-OBJECT)
          (CL:NOT (TRUE? DEP))))
        (CL:SETQ ALWAYS?-000 FALSE) (CL:RETURN))))
     (CL:WHEN ALWAYS?-000 (POST-FOR-EVALUATION DEP))))))

;;; (DEFMETHOD EVALUATE-TIGHTER-INTERVAL ...)

(CL:DEFMETHOD /PL-KERNEL-KB/EVALUATE-TIGHTER-INTERVAL ((INTERVAL /PL-KERNEL-KB/INTERVAL-CACHE)))

;;; (DEFMETHOD EVALUATE-TIGHTER-INTERVAL ...)

(CL:DEFMETHOD /PL-KERNEL-KB/EVALUATE-TIGHTER-INTERVAL ((INTERVAL /PL-KERNEL-KB/INTEGER-INTERVAL-CACHE))
  (CL:WHEN
   (CL:AND (CL:NOT (CL:EQ *TRACED-KEYWORDS* NULL))
    (MEMB? *TRACED-KEYWORDS* /PL-KERNEL-KB/KWD-ARITHMETIC-PROPAGATE))
   (%%PRINT-STREAM (%NATIVE-STREAM STANDARD-OUTPUT) "TIGHTER BOUNDS ON: "
    (/PL-KERNEL-KB/%INTERVAL-MEMBER INTERVAL) EOL "   LB: "
    (%LOWER-BOUND INTERVAL) "   UB: " (%UPPER-BOUND INTERVAL) EOL))
  (/PL-KERNEL-KB/EVALUATE-ADJACENT-INEQUALITIES
   (/PL-KERNEL-KB/%INTERVAL-MEMBER INTERVAL))
  (CL:WHEN
   (CL:OR (NULL? (%LOWER-BOUND INTERVAL)) (NULL? (%UPPER-BOUND INTERVAL)))
   (CL:RETURN-FROM /PL-KERNEL-KB/EVALUATE-TIGHTER-INTERVAL))
  (CL:COND
   ((CL:= (%LOWER-BOUND INTERVAL) (%UPPER-BOUND INTERVAL))
    (EQUATE-VALUES (/PL-KERNEL-KB/%INTERVAL-MEMBER INTERVAL)
     (WRAP-INTEGER (%LOWER-BOUND INTERVAL))))
   ((CL:> (%LOWER-BOUND INTERVAL) (%UPPER-BOUND INTERVAL))
    (/PL-KERNEL-KB/SIGNAL-INTERVAL-CLASH INTERVAL))))

;;; (DEFMETHOD EVALUATE-TIGHTER-INTERVAL ...)

(CL:DEFMETHOD /PL-KERNEL-KB/EVALUATE-TIGHTER-INTERVAL ((INTERVAL /PL-KERNEL-KB/FLOAT-INTERVAL-CACHE))
  (CL:WHEN
   (CL:AND (CL:NOT (CL:= (%LOWER-BOUND INTERVAL) NULL-FLOAT))
    (CL:NOT (CL:= (%UPPER-BOUND INTERVAL) NULL-FLOAT)))
   (CL:COND
    ((CL:= (%LOWER-BOUND INTERVAL) (%UPPER-BOUND INTERVAL))
     (CL:IF
      (CL:OR (/PL-KERNEL-KB/%STRICT-LOWER-BOUND? INTERVAL)
       (/PL-KERNEL-KB/%STRICT-UPPER-BOUND? INTERVAL))
      (/PL-KERNEL-KB/SIGNAL-INTERVAL-CLASH INTERVAL)
      (EQUATE-VALUES (/PL-KERNEL-KB/%INTERVAL-MEMBER INTERVAL)
       (WRAP-FLOAT (%LOWER-BOUND INTERVAL)))))
    ((CL:> (%LOWER-BOUND INTERVAL) (%UPPER-BOUND INTERVAL))
     (/PL-KERNEL-KB/SIGNAL-INTERVAL-CLASH INTERVAL))))
  (/PL-KERNEL-KB/EVALUATE-ADJACENT-INEQUALITIES
   (/PL-KERNEL-KB/%INTERVAL-MEMBER INTERVAL)))

;;; (DEFMETHOD PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE ...)

(CL:DEFMETHOD /PL-KERNEL-KB/PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE ((SELF /PL-KERNEL-KB/INTERVAL-CACHE) VALUE OPERATOR)
  (CL:PROGN (CL:SETQ OPERATOR OPERATOR) (CL:SETQ VALUE VALUE)))

;;; (DEFMETHOD PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE ...)

(CL:DEFMETHOD /PL-KERNEL-KB/PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE ((SELF /PL-KERNEL-KB/INTEGER-INTERVAL-CACHE) VALUE OPERATOR)
  (CL:LET*
   ((INTEGERVALUE
     (/PL-KERNEL-KB/COERCE-INTERVAL-BOUND-TO-INTEGER VALUE OPERATOR)))
   (CL:DECLARE (CL:TYPE CL:FIXNUM INTEGERVALUE))
   (CL:WHEN (NULL? INTEGERVALUE)
    (CL:RETURN-FROM /PL-KERNEL-KB/PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE))
   (CL:COND
    ((CL:OR
      (CL:EQ OPERATOR
       /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN)
      (CL:EQ OPERATOR
       /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL))
     (CL:WHEN
      (CL:OR (NULL? (%LOWER-BOUND SELF))
       (CL:> INTEGERVALUE (%LOWER-BOUND SELF)))
      (CL:SETF (%LOWER-BOUND SELF) INTEGERVALUE)
      (/PL-KERNEL-KB/EVALUATE-TIGHTER-INTERVAL SELF)))
    ((CL:OR
      (CL:EQ OPERATOR /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN)
      (CL:EQ OPERATOR
       /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL))
     (CL:WHEN
      (CL:OR (NULL? (%UPPER-BOUND SELF))
       (CL:< INTEGERVALUE (%UPPER-BOUND SELF)))
      (CL:SETF (%UPPER-BOUND SELF) INTEGERVALUE)
      (/PL-KERNEL-KB/EVALUATE-TIGHTER-INTERVAL SELF)))
    (CL:T
     (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
      (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" OPERATOR
       "' is not a valid case option")
      (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000))))))))

;;; (DEFMETHOD PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE ...)

(CL:DEFMETHOD /PL-KERNEL-KB/PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE ((SELF /PL-KERNEL-KB/FLOAT-INTERVAL-CACHE) VALUE OPERATOR)
  (CL:LET*
   ((FLOATVALUE (NUMBER-WRAPPER-TO-FLOAT VALUE)) (TIGHTERINTERVAL? FALSE))
   (CL:DECLARE (CL:TYPE CL:DOUBLE-FLOAT FLOATVALUE))
   (CL:WHEN (CL:= FLOATVALUE NULL-FLOAT)
    (CL:RETURN-FROM /PL-KERNEL-KB/PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE))
   (CL:COND
    ((CL:EQ OPERATOR
      /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN)
     (CL:WHEN
      (CL:OR (CL:= (%LOWER-BOUND SELF) NULL-FLOAT)
       (CL:> FLOATVALUE (%LOWER-BOUND SELF)))
      (CL:SETF (%LOWER-BOUND SELF) FLOATVALUE)
      (CL:SETF (/PL-KERNEL-KB/%STRICT-LOWER-BOUND? SELF) TRUE)
      (CL:SETQ TIGHTERINTERVAL? TRUE)))
    ((CL:EQ OPERATOR
      /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL)
     (CL:WHEN
      (CL:OR (CL:= (%LOWER-BOUND SELF) NULL-FLOAT)
       (CL:> FLOATVALUE (%LOWER-BOUND SELF)))
      (CL:SETF (%LOWER-BOUND SELF) FLOATVALUE)
      (CL:SETF (/PL-KERNEL-KB/%STRICT-LOWER-BOUND? SELF) FALSE)
      (CL:SETQ TIGHTERINTERVAL? TRUE)))
    ((CL:EQ OPERATOR /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN)
     (CL:WHEN
      (CL:OR (CL:= (%UPPER-BOUND SELF) NULL-FLOAT)
       (CL:< FLOATVALUE (%UPPER-BOUND SELF)))
      (CL:SETF (%UPPER-BOUND SELF) FLOATVALUE)
      (CL:SETF (/PL-KERNEL-KB/%STRICT-UPPER-BOUND? SELF) TRUE)
      (CL:SETQ TIGHTERINTERVAL? TRUE)))
    ((CL:EQ OPERATOR
      /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL)
     (CL:WHEN
      (CL:OR (CL:= (%UPPER-BOUND SELF) NULL-FLOAT)
       (CL:< FLOATVALUE (%UPPER-BOUND SELF)))
      (CL:SETF (%UPPER-BOUND SELF) FLOATVALUE)
      (CL:SETF (/PL-KERNEL-KB/%STRICT-UPPER-BOUND? SELF) FALSE)
      (CL:SETQ TIGHTERINTERVAL? TRUE)))
    (CL:T
     (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
      (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" OPERATOR
       "' is not a valid case option")
      (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000))))))
   (CL:WHEN TIGHTERINTERVAL?
    (/PL-KERNEL-KB/EVALUATE-TIGHTER-INTERVAL SELF))))

;;; (DEFUN (INVERSE-INEQUALITY-OPERATOR SURROGATE) ...)

(CL:DEFUN /PL-KERNEL-KB/INVERSE-INEQUALITY-OPERATOR (OPERATOR)
  (CL:COND
   ((CL:EQ OPERATOR
     /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN)
    /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN)
   ((CL:EQ OPERATOR /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN)
    /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN)
   ((CL:EQ OPERATOR
     /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL)
    /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL)
   ((CL:EQ OPERATOR
     /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL)
    /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL)
   (CL:T
    (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
     (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" OPERATOR
      "' is not a valid case option")
     (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))))

;;; (DEFUN UNIFY-INTERVAL-CACHES ...)

(CL:DEFUN /PL-KERNEL-KB/UNIFY-INTERVAL-CACHES (CACHE1 CACHE2 OPERATOR)
  (CL:COND
   ((CL:OR
     (CL:EQ OPERATOR
      /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN)
     (CL:EQ OPERATOR
      /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL))
    (/PL-KERNEL-KB/PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE CACHE1
     (/PL-KERNEL-KB/ACCESS-INTERVAL-CACHE-BOUNDS CACHE2
      /PL-KERNEL-KB/KWD-ARITHMETIC-LOWER-BOUND)
     OPERATOR)
    (/PL-KERNEL-KB/PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE CACHE2
     (/PL-KERNEL-KB/ACCESS-INTERVAL-CACHE-BOUNDS CACHE1
      /PL-KERNEL-KB/KWD-ARITHMETIC-UPPER-BOUND)
     (/PL-KERNEL-KB/INVERSE-INEQUALITY-OPERATOR OPERATOR)))
   ((CL:OR
     (CL:EQ OPERATOR /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN)
     (CL:EQ OPERATOR
      /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL))
    (/PL-KERNEL-KB/PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE CACHE1
     (/PL-KERNEL-KB/ACCESS-INTERVAL-CACHE-BOUNDS CACHE2
      /PL-KERNEL-KB/KWD-ARITHMETIC-UPPER-BOUND)
     OPERATOR)
    (/PL-KERNEL-KB/PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE CACHE2
     (/PL-KERNEL-KB/ACCESS-INTERVAL-CACHE-BOUNDS CACHE1
      /PL-KERNEL-KB/KWD-ARITHMETIC-LOWER-BOUND)
     (/PL-KERNEL-KB/INVERSE-INEQUALITY-OPERATOR OPERATOR)))
   (CL:T
    (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
     (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" OPERATOR
      "' is not a valid case option")
     (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))))

;;; (DEFUN (ACCESS-INTERVAL-BOUNDS NUMBER-WRAPPER BOOLEAN) ...)

(CL:DEFUN /PL-KERNEL-KB/ACCESS-INTERVAL-BOUNDS (X LOWERORUPPER)
  (CL:COND
   ((SUBTYPE-OF? (SAFE-PRIMARY-TYPE X)
     /PL-KERNEL-KB/SGT-ARITHMETIC-STELLA-NUMBER-WRAPPER)
    (CL:PROGN (CL:VALUES X FALSE)))
   (CL:T
    (/PL-KERNEL-KB/ACCESS-INTERVAL-CACHE-BOUNDS
     (ACCESS-BINARY-VALUE X
      /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-INTERVAL-CACHE-OF)
     LOWERORUPPER))))

;;; (DEFUN (ACCESS-INTERVAL-CACHE-BOUNDS NUMBER-WRAPPER BOOLEAN) ...)

(CL:DEFUN /PL-KERNEL-KB/ACCESS-INTERVAL-CACHE-BOUNDS (INTERVALCACHE LOWERORUPPER)
  (CL:WHEN (CL:EQ INTERVALCACHE NULL)
   (CL:RETURN-FROM /PL-KERNEL-KB/ACCESS-INTERVAL-CACHE-BOUNDS
    (CL:VALUES NULL FALSE)))
  (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE INTERVALCACHE)))
   (CL:COND
    ((SUBTYPE-OF? TEST-VALUE-000
      /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-INTEGER-INTERVAL-CACHE)
     (CL:PROGN
      (CL:COND
       ((CL:EQ LOWERORUPPER /PL-KERNEL-KB/KWD-ARITHMETIC-LOWER-BOUND)
        (CL:VALUES (WRAP-INTEGER (%LOWER-BOUND INTERVALCACHE)) FALSE))
       ((CL:EQ LOWERORUPPER /PL-KERNEL-KB/KWD-ARITHMETIC-UPPER-BOUND)
        (CL:VALUES (WRAP-INTEGER (%UPPER-BOUND INTERVALCACHE)) FALSE))
       (CL:T
        (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
         (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" LOWERORUPPER
          "' is not a valid case option")
         (CL:ERROR
          (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000))))))))
    ((SUBTYPE-OF? TEST-VALUE-000
      /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-FLOAT-INTERVAL-CACHE)
     (CL:PROGN
      (CL:COND
       ((CL:EQ LOWERORUPPER /PL-KERNEL-KB/KWD-ARITHMETIC-LOWER-BOUND)
        (CL:VALUES (WRAP-FLOAT (%LOWER-BOUND INTERVALCACHE))
         (/PL-KERNEL-KB/%STRICT-LOWER-BOUND? INTERVALCACHE)))
       ((CL:EQ LOWERORUPPER /PL-KERNEL-KB/KWD-ARITHMETIC-UPPER-BOUND)
        (CL:VALUES (WRAP-FLOAT (%UPPER-BOUND INTERVALCACHE))
         (/PL-KERNEL-KB/%STRICT-UPPER-BOUND? INTERVALCACHE)))
       (CL:T
        (CL:LET* ((STREAM-001 (NEW-OUTPUT-STRING-STREAM)))
         (%%PRINT-STREAM (%NATIVE-STREAM STREAM-001) "`" LOWERORUPPER
          "' is not a valid case option")
         (CL:ERROR
          (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-001))))))))
    (CL:T
     (CL:LET* ((STREAM-002 (NEW-OUTPUT-STRING-STREAM)))
      (%%PRINT-STREAM (%NATIVE-STREAM STREAM-002) "`" TEST-VALUE-000
       "' is not a valid case option")
      (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-002))))))))

;;; (DEFUN (COMPARE-INTERVAL-BOUNDS? BOOLEAN) ...)

(CL:DEFUN /PL-KERNEL-KB/COMPARE-INTERVAL-BOUNDS? (RELATION X Y)
  (CL:WHEN
   (CL:OR (/PL-KERNEL-KB/NULL-NUMBER? X) (/PL-KERNEL-KB/NULL-NUMBER? Y))
   (CL:RETURN-FROM /PL-KERNEL-KB/COMPARE-INTERVAL-BOUNDS? FALSE))
  (CL:COND
   ((CL:EQ RELATION
     /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL)
    (<= (NUMBER-WRAPPER-TO-FLOAT X) (NUMBER-WRAPPER-TO-FLOAT Y)))
   ((CL:EQ RELATION /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN)
    (< (NUMBER-WRAPPER-TO-FLOAT X) (NUMBER-WRAPPER-TO-FLOAT Y)))
   (CL:T (CL:ERROR (NEW-STELLA-EXCEPTION "Shouldn't get here!")))))

;;; (DEFUN (NULL-NUMBER? BOOLEAN) ...)

(CL:DEFUN /PL-KERNEL-KB/NULL-NUMBER? (SELF)
  (CL:WHEN (CL:EQ SELF NULL)
   (CL:RETURN-FROM /PL-KERNEL-KB/NULL-NUMBER? TRUE))
  (CL:LET* ((TEST-VALUE-000 (SAFE-PRIMARY-TYPE SELF)))
   (CL:COND
    ((SUBTYPE-OF-INTEGER? TEST-VALUE-000)
     (CL:PROGN (NULL? (%WRAPPER-VALUE SELF))))
    ((SUBTYPE-OF-FLOAT? TEST-VALUE-000)
     (CL:PROGN (CL:= (%WRAPPER-VALUE SELF) NULL-FLOAT)))
    (CL:T
     (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
      (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" TEST-VALUE-000
       "' is not a valid case option")
      (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000))))))))

;;; (DEFUN (LESS-SPECIALIST KEYWORD) ...)

(CL:DEFUN /PL-KERNEL-KB/LESS-SPECIALIST (FRAME LASTMOVE)
  (CL:LET*
   ((PROPOSITION (%PROPOSITION FRAME)) (RELATION (%OPERATOR PROPOSITION))
    (XARG
     (CL:AREF
      (CL:THE CL:SIMPLE-VECTOR (%THE-ARRAY (%ARGUMENTS PROPOSITION))) 0))
    (YARG
     (CL:AREF
      (CL:THE CL:SIMPLE-VECTOR (%THE-ARRAY (%ARGUMENTS PROPOSITION))) 1))
    (X (ARGUMENT-BOUND-TO XARG)) (Y (ARGUMENT-BOUND-TO YARG)) (XUB NULL)
    (STRICTX? FALSE) (YLB NULL) (STRICTY? FALSE))
   (CL:SETQ LASTMOVE LASTMOVE)
   (CL:LET* ((SUCCESS? FALSE))
    (CL:WHEN (CL:EQ Y NULL)
     (CL:WHEN (CL:EQ X NULL)
      (CL:RETURN-FROM /PL-KERNEL-KB/LESS-SPECIALIST
       /PL-KERNEL-KB/KWD-ARITHMETIC-TERMINAL-FAILURE))
     (CL:MULTIPLE-VALUE-SETQ (XUB STRICTX?)
      (/PL-KERNEL-KB/ACCESS-INTERVAL-BOUNDS X
       /PL-KERNEL-KB/KWD-ARITHMETIC-UPPER-BOUND))
     (CL:COND
      ((CL:EQ RELATION
        /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN)
       (CL:WHEN
        (CL:AND (CL:NOT (/PL-KERNEL-KB/NULL-NUMBER? XUB))
         (ISA? XUB /PL-KERNEL-KB/SGT-ARITHMETIC-STELLA-INTEGER-WRAPPER))
        (CL:SETQ XUB (WRAP-INTEGER (CL:1+ (%WRAPPER-VALUE XUB))))))
      (CL:T))
     (CL:WHEN (CL:NOT (/PL-KERNEL-KB/NULL-NUMBER? XUB))
      (CL:SETQ SUCCESS? (BIND-VARIABLE-TO-VALUE? YARG XUB TRUE)))
     (CL:RETURN-FROM /PL-KERNEL-KB/LESS-SPECIALIST
      (SELECT-PROOF-RESULT SUCCESS? FALSE FALSE)))
    (CL:WHEN (CL:EQ X NULL)
     (CL:MULTIPLE-VALUE-SETQ (YLB STRICTY?)
      (/PL-KERNEL-KB/ACCESS-INTERVAL-BOUNDS Y
       /PL-KERNEL-KB/KWD-ARITHMETIC-LOWER-BOUND))
     (CL:COND
      ((CL:EQ RELATION
        /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN)
       (CL:WHEN
        (CL:AND (CL:NOT (/PL-KERNEL-KB/NULL-NUMBER? YLB))
         (ISA? YLB /PL-KERNEL-KB/SGT-ARITHMETIC-STELLA-INTEGER-WRAPPER))
        (CL:SETQ YLB (WRAP-INTEGER (CL:1- (%WRAPPER-VALUE YLB))))))
      (CL:T))
     (CL:WHEN (CL:NOT (/PL-KERNEL-KB/NULL-NUMBER? YLB))
      (CL:SETQ SUCCESS? (BIND-VARIABLE-TO-VALUE? XARG YLB TRUE)))
     (CL:RETURN-FROM /PL-KERNEL-KB/LESS-SPECIALIST
      (SELECT-PROOF-RESULT SUCCESS? FALSE FALSE))))
   (CL:WHEN *REVERSEPOLARITY?*
    (CL:LET* ((TEMPNUMBER X)) (CL:SETQ X Y) (CL:SETQ Y TEMPNUMBER))
    (CL:COND
     ((CL:EQ RELATION /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN)
      (CL:SETQ RELATION
       /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL))
     ((CL:EQ RELATION
       /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL)
      (CL:SETQ RELATION
       /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN))
     (CL:T
      (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
       (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" RELATION
        "' is not a valid case option")
       (CL:ERROR
        (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000)))))))
   (CL:LET* ((SUCCESS? FALSE))
    (CL:MULTIPLE-VALUE-SETQ (XUB STRICTX?)
     (/PL-KERNEL-KB/ACCESS-INTERVAL-BOUNDS X
      /PL-KERNEL-KB/KWD-ARITHMETIC-UPPER-BOUND))
    (CL:MULTIPLE-VALUE-SETQ (YLB STRICTY?)
     (/PL-KERNEL-KB/ACCESS-INTERVAL-BOUNDS Y
      /PL-KERNEL-KB/KWD-ARITHMETIC-LOWER-BOUND))
    (CL:COND
     ((CL:EQ RELATION /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN)
      (CL:SETQ SUCCESS?
       (CL:OR
        (CL:AND (CL:OR STRICTX? STRICTY?)
         (/PL-KERNEL-KB/COMPARE-INTERVAL-BOUNDS?
          /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL XUB
          YLB))
        (/PL-KERNEL-KB/COMPARE-INTERVAL-BOUNDS?
         /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN XUB YLB))))
     ((CL:EQ RELATION
       /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL)
      (CL:SETQ SUCCESS?
       (/PL-KERNEL-KB/COMPARE-INTERVAL-BOUNDS? RELATION XUB YLB)))
     (CL:T
      (CL:LET* ((STREAM-001 (NEW-OUTPUT-STRING-STREAM)))
       (%%PRINT-STREAM (%NATIVE-STREAM STREAM-001) "`" RELATION
        "' is not a valid case option")
       (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-001))))))
    (CL:WHEN SUCCESS?
     (CL:RETURN-FROM /PL-KERNEL-KB/LESS-SPECIALIST
      /PL-KERNEL-KB/KWD-ARITHMETIC-FINAL-SUCCESS)))
   (CL:IF (CL:AND (SKOLEM? X) (SKOLEM? Y))
    /PL-KERNEL-KB/KWD-ARITHMETIC-FAILURE
    /PL-KERNEL-KB/KWD-ARITHMETIC-TERMINAL-FAILURE)))

;;; (DEFUN (GREATER-SPECIALIST KEYWORD) ...)

(CL:DEFUN /PL-KERNEL-KB/GREATER-SPECIALIST (FRAME LASTMOVE)
  (CL:LET*
   ((PROPOSITION (%PROPOSITION FRAME)) (RELATION (%OPERATOR PROPOSITION))
    (ARGUMENTS (%ARGUMENTS PROPOSITION)))
   (CL:COND
    ((CL:EQ RELATION
      /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN)
     (CL:SETF (%OPERATOR PROPOSITION)
      /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN))
    ((CL:EQ RELATION
      /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL)
     (CL:SETF (%OPERATOR PROPOSITION)
      /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL))
    (CL:T
     (CL:LET* ((STREAM-000 (NEW-OUTPUT-STRING-STREAM)))
      (%%PRINT-STREAM (%NATIVE-STREAM STREAM-000) "`" RELATION
       "' is not a valid case option")
      (CL:ERROR (NEW-STELLA-EXCEPTION (THE-STRING-READER STREAM-000))))))
   (CL:LET*
    ((TEMP (CL:AREF (CL:THE CL:SIMPLE-VECTOR (%THE-ARRAY ARGUMENTS)) 0)))
    (CL:LET
     ((SELF (%THE-ARRAY ARGUMENTS))
      (/STELLA/VALUE
       (CL:AREF (CL:THE CL:SIMPLE-VECTOR (%THE-ARRAY ARGUMENTS)) 1))
      (POSITION 0))
     (CL:DECLARE (CL:TYPE CL:SIMPLE-VECTOR SELF)
      (CL:TYPE CL:FIXNUM POSITION))
     (CL:SETF (CL:AREF SELF POSITION) /STELLA/VALUE))
    (CL:LET
     ((SELF (%THE-ARRAY ARGUMENTS)) (/STELLA/VALUE TEMP) (POSITION 1))
     (CL:DECLARE (CL:TYPE CL:SIMPLE-VECTOR SELF)
      (CL:TYPE CL:FIXNUM POSITION))
     (CL:SETF (CL:AREF SELF POSITION) /STELLA/VALUE)))
   (/PL-KERNEL-KB/LESS-SPECIALIST FRAME LASTMOVE)))

;;; (DEFUN INEQUALITY-EVALUATOR ...)

(CL:DEFUN /PL-KERNEL-KB/INEQUALITY-EVALUATOR (SELF)
  (CL:LET*
   ((VALUE1
     (VALUE-OF
      (CL:AREF (CL:THE CL:SIMPLE-VECTOR (%THE-ARRAY (%ARGUMENTS SELF)))
       0)))
    (VALUE2
     (VALUE-OF
      (CL:AREF (CL:THE CL:SIMPLE-VECTOR (%THE-ARRAY (%ARGUMENTS SELF)))
       1)))
    (SKOLEM1?
     (ISA? VALUE1 /PL-KERNEL-KB/SGT-ARITHMETIC-LOGIC-LOGIC-OBJECT))
    (SKOLEM2?
     (ISA? VALUE2 /PL-KERNEL-KB/SGT-ARITHMETIC-LOGIC-LOGIC-OBJECT))
    (OPERATOR (%OPERATOR SELF)))
   (CL:IF SKOLEM1?
    (CL:IF SKOLEM2?
     (/PL-KERNEL-KB/UNIFY-INTERVAL-CACHES
      (/PL-KERNEL-KB/GET-INTERVAL-CACHE VALUE1)
      (/PL-KERNEL-KB/GET-INTERVAL-CACHE VALUE2) OPERATOR)
     (/PL-KERNEL-KB/PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE
      (/PL-KERNEL-KB/GET-INTERVAL-CACHE VALUE1) VALUE2 OPERATOR))
    (CL:IF SKOLEM2?
     (/PL-KERNEL-KB/PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE
      (/PL-KERNEL-KB/GET-INTERVAL-CACHE VALUE2) VALUE1
      (/PL-KERNEL-KB/INVERSE-INEQUALITY-OPERATOR OPERATOR))
     (EVALUATE-PREDICATE-PROPOSITION SELF)))))

;;; (DEFUN (LENGTH-COMPUTATION INTEGER-WRAPPER) ...)

(CL:DEFUN /PL-KERNEL-KB/LENGTH-COMPUTATION (X)
  (CL:COND
   ((SUBTYPE-OF-STRING? (SAFE-PRIMARY-TYPE X))
    (CL:PROGN
     (WRAP-INTEGER
      (CL:THE CL:FIXNUM
       (CL:LENGTH (CL:THE CL:SIMPLE-STRING (%WRAPPER-VALUE X)))))))
   (CL:T
    (%%PRINT-STREAM (%NATIVE-STREAM STANDARD-OUTPUT)
     "Length computation not yet implemented for Lists")
    (WRAP-INTEGER NULL-INTEGER))))

(CL:DEFUN /PL-KERNEL-KB/HELP-STARTUP-ARITHMETIC1 ()
  (CL:PROGN
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-PLUS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PLUS" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?X" (GET-STELLA-MODULE "/LOGIC" TRUE)
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "NUMBER"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?Y" (GET-STELLA-MODULE "/LOGIC" TRUE)
     0))
   (CL:SETQ /PL-KERNEL-KB/KWD-ARITHMETIC-->
    (INTERN-RIGID-SYMBOL-WRT-MODULE "->" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?Z" (GET-STELLA-MODULE "/LOGIC" TRUE)
     0))
   (CL:SETQ /PL-KERNEL-KB/KWD-ARITHMETIC-DOCUMENTATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DOCUMENTATION" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/KWD-ARITHMETIC-AXIOMS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "AXIOMS" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND
    (INTERN-RIGID-SYMBOL-WRT-MODULE "AND"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-COMPUTED
    (INTERN-RIGID-SYMBOL-WRT-MODULE "COMPUTED" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-CONSTRAINT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "RELATION-CONSTRAINT" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-PLUS-CONSTRAINT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PLUS-CONSTRAINT" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "RELATION-SPECIALIST" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-CONSTRAINT-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CONSTRAINT-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-MINUS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MINUS" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-MINUS-CONSTRAINT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MINUS-CONSTRAINT" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-TIMES
    (INTERN-RIGID-SYMBOL-WRT-MODULE "TIMES" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-TIMES-CONSTRAINT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "TIMES-CONSTRAINT" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-DIVIDE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DIVIDE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-DIVIDE-CONSTRAINT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DIVIDE-CONSTRAINT" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SQUARE-ROOT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SQUARE-ROOT" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SQUARE-ROOT-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SQUARE-ROOT-SPECIALIST" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-HANDLES-REVERSE-POLARITY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "HANDLES-REVERSE-POLARITY" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LESS-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "GREATER-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INEQUALITY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INEQUALITY" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/KWD-ARITHMETIC-<<=
    (INTERN-RIGID-SYMBOL-WRT-MODULE "<<=" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LESS-OR-EQUAL" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "GREATER-OR-EQUAL" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-ABSTRACT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "ABSTRACT"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-THAN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LESS-THAN" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-EXISTS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "EXISTS"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-EVALUATOR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "RELATION-EVALUATOR" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INEQUALITY-EVALUATOR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INEQUALITY-EVALUATOR" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "GREATER-THAN" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/KWD-ARITHMETIC-<<=>>
    (INTERN-RIGID-SYMBOL-WRT-MODULE "<<=>>" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SYNONYM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SYNONYM" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-+
    (INTERN-RIGID-SYMBOL-WRT-MODULE "+" (GET-STELLA-MODULE "/STELLA" TRUE)
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-=
    (INTERN-RIGID-SYMBOL-WRT-MODULE "=" (GET-STELLA-MODULE "/STELLA" TRUE)
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-*
    (INTERN-RIGID-SYMBOL-WRT-MODULE "*" (GET-STELLA-MODULE "/STELLA" TRUE)
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-<
    (INTERN-RIGID-SYMBOL-WRT-MODULE "<" (GET-STELLA-MODULE "/STELLA" TRUE)
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-=<
    (INTERN-RIGID-SYMBOL-WRT-MODULE "=<"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA->
    (INTERN-RIGID-SYMBOL-WRT-MODULE ">" (GET-STELLA-MODULE "/STELLA" TRUE)
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA->=
    (INTERN-RIGID-SYMBOL-WRT-MODULE ">="
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-INTERVAL-CACHE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INTERVAL-CACHE" NULL 1))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-HOME-CONTEXT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "HOME-CONTEXT"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INTERVAL-MEMBER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INTERVAL-MEMBER" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-INTEGER-INTERVAL-CACHE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INTEGER-INTERVAL-CACHE" NULL 1))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-LOWER-BOUND
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LOWER-BOUND"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-UPPER-BOUND
    (INTERN-RIGID-SYMBOL-WRT-MODULE "UPPER-BOUND"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-FLOAT-INTERVAL-CACHE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "FLOAT-INTERVAL-CACHE" NULL 1))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-STRICT-LOWER-BOUND?
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STRICT-LOWER-BOUND?" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-STRICT-UPPER-BOUND?
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STRICT-UPPER-BOUND?" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INTERVAL-CACHE-OF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INTERVAL-CACHE-OF" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-?B
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?B" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INTERVAL-CACHE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INTERVAL-CACHE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-HIDDEN-RELATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "HIDDEN-RELATION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-INTERVAL-CACHE-OF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INTERVAL-CACHE-OF" NULL 1))
   (CL:SETQ /PL-KERNEL-KB/SGT-ARITHMETIC-STELLA-INTEGER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INTEGER"
     (GET-STELLA-MODULE "/STELLA" TRUE) 1))
   (CL:SETQ /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "GREATER-THAN" NULL 1))))

(CL:DEFUN /PL-KERNEL-KB/HELP-STARTUP-ARITHMETIC2 ()
  (CL:PROGN
   (CL:SETQ /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "GREATER-OR-EQUAL" NULL 1))
   (CL:SETQ /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-THAN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LESS-THAN" NULL 1))
   (CL:SETQ /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LESS-OR-EQUAL" NULL 1))
   (CL:SETQ /PL-KERNEL-KB/SGT-ARITHMETIC-PL-KERNEL-KB-INEQUALITY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INEQUALITY" NULL 1))
   (CL:SETQ /PL-KERNEL-KB/SGT-ARITHMETIC-LOGIC-LOGIC-OBJECT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LOGIC-OBJECT"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 1))
   (CL:SETQ /PL-KERNEL-KB/KWD-ARITHMETIC-PROPAGATE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PROPAGATE" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/KWD-ARITHMETIC-LOWER-BOUND
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LOWER-BOUND" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/KWD-ARITHMETIC-UPPER-BOUND
    (INTERN-RIGID-SYMBOL-WRT-MODULE "UPPER-BOUND" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/SGT-ARITHMETIC-STELLA-NUMBER-WRAPPER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "NUMBER-WRAPPER"
     (GET-STELLA-MODULE "/STELLA" TRUE) 1))
   (CL:SETQ /PL-KERNEL-KB/KWD-ARITHMETIC-TERMINAL-FAILURE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "TERMINAL-FAILURE" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/SGT-ARITHMETIC-STELLA-INTEGER-WRAPPER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INTEGER-WRAPPER"
     (GET-STELLA-MODULE "/STELLA" TRUE) 1))
   (CL:SETQ /PL-KERNEL-KB/KWD-ARITHMETIC-FINAL-SUCCESS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "FINAL-SUCCESS" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/KWD-ARITHMETIC-FAILURE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "FAILURE" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-LENGTH
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LENGTH"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-THING
    (INTERN-RIGID-SYMBOL-WRT-MODULE "THING"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-INTEGER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INTEGER"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-COMPUTATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "RELATION-COMPUTATION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LENGTH-COMPUTATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LENGTH-COMPUTATION" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-COMPUTATION-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "COMPUTATION-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-STARTUP-ARITHMETIC
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STARTUP-ARITHMETIC" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-METHOD-STARTUP-CLASSNAME
    (INTERN-RIGID-SYMBOL-WRT-MODULE "METHOD-STARTUP-CLASSNAME"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))))

(CL:DEFUN /PL-KERNEL-KB/HELP-STARTUP-ARITHMETIC3 ()
  (CL:PROGN
   (DEFINE-FUNCTION-OBJECT "ARITHMETIC-EQUAL-TEST"
    "(DEFUN (ARITHMETIC-EQUAL-TEST BOOLEAN) ((X NUMBER-WRAPPER) (Y NUMBER-WRAPPER)) :PUBLIC? TRUE)"
    (CL:FUNCTION /PL-KERNEL-KB/ARITHMETIC-EQUAL-TEST) NULL)
   (DEFINE-FUNCTION-OBJECT "ARITHMETIC-LESS-TEST"
    "(DEFUN (ARITHMETIC-LESS-TEST BOOLEAN) ((X NUMBER-WRAPPER) (Y NUMBER-WRAPPER)) :PUBLIC? TRUE)"
    (CL:FUNCTION /PL-KERNEL-KB/ARITHMETIC-LESS-TEST) NULL)
   (DEFINE-FUNCTION-OBJECT "ARITHMETIC-GREATER-TEST"
    "(DEFUN (ARITHMETIC-GREATER-TEST BOOLEAN) ((X NUMBER-WRAPPER) (Y NUMBER-WRAPPER)) :PUBLIC? TRUE)"
    (CL:FUNCTION /PL-KERNEL-KB/ARITHMETIC-GREATER-TEST) NULL)
   (DEFINE-FUNCTION-OBJECT "PLUS-COMPUTATION"
    "(DEFUN (PLUS-COMPUTATION NUMBER-WRAPPER) ((X NUMBER-WRAPPER) (Y NUMBER-WRAPPER)) :PUBLIC? TRUE)"
    (CL:FUNCTION /PL-KERNEL-KB/PLUS-COMPUTATION) NULL)
   (DEFINE-FUNCTION-OBJECT "MINUS-COMPUTATION"
    "(DEFUN (MINUS-COMPUTATION NUMBER-WRAPPER) ((X NUMBER-WRAPPER) (Y NUMBER-WRAPPER)) :PUBLIC? TRUE)"
    (CL:FUNCTION /PL-KERNEL-KB/MINUS-COMPUTATION) NULL)
   (DEFINE-FUNCTION-OBJECT "TIMES-COMPUTATION"
    "(DEFUN (TIMES-COMPUTATION NUMBER-WRAPPER) ((X NUMBER-WRAPPER) (Y NUMBER-WRAPPER)) :PUBLIC? TRUE)"
    (CL:FUNCTION /PL-KERNEL-KB/TIMES-COMPUTATION) NULL)
   (DEFINE-FUNCTION-OBJECT "DIVIDE-COMPUTATION"
    "(DEFUN (DIVIDE-COMPUTATION NUMBER-WRAPPER) ((X NUMBER-WRAPPER) (Y NUMBER-WRAPPER)) :PUBLIC? TRUE)"
    (CL:FUNCTION /PL-KERNEL-KB/DIVIDE-COMPUTATION) NULL)
   (DEFINE-FUNCTION-OBJECT "SQRT-COMPUTATION"
    "(DEFUN (SQRT-COMPUTATION NUMBER-WRAPPER) ((X NUMBER-WRAPPER)) :PUBLIC? TRUE)"
    (CL:FUNCTION /PL-KERNEL-KB/SQRT-COMPUTATION) NULL)
   (DEFINE-FUNCTION-OBJECT "PLUS-CONSTRAINT"
    "(DEFUN (PLUS-CONSTRAINT OBJECT) ((MISSING-ARGUMENT INTEGER-WRAPPER) (X1 NUMBER-WRAPPER) (X2 NUMBER-WRAPPER) (X3 NUMBER-WRAPPER)))"
    (CL:FUNCTION /PL-KERNEL-KB/PLUS-CONSTRAINT) NULL)
   (DEFINE-FUNCTION-OBJECT "MINUS-CONSTRAINT"
    "(DEFUN (MINUS-CONSTRAINT OBJECT) ((MISSING-ARGUMENT INTEGER-WRAPPER) (X1 NUMBER-WRAPPER) (X2 NUMBER-WRAPPER) (X3 NUMBER-WRAPPER)))"
    (CL:FUNCTION /PL-KERNEL-KB/MINUS-CONSTRAINT) NULL)
   (DEFINE-FUNCTION-OBJECT "TIMES-CONSTRAINT"
    "(DEFUN (TIMES-CONSTRAINT OBJECT) ((MISSING-ARGUMENT INTEGER-WRAPPER) (X1 NUMBER-WRAPPER) (X2 NUMBER-WRAPPER) (X3 NUMBER-WRAPPER)))"
    (CL:FUNCTION /PL-KERNEL-KB/TIMES-CONSTRAINT) NULL)
   (DEFINE-FUNCTION-OBJECT "DIVIDE-CONSTRAINT"
    "(DEFUN (DIVIDE-CONSTRAINT OBJECT) ((MISSING-ARGUMENT INTEGER-WRAPPER) (X1 NUMBER-WRAPPER) (X2 NUMBER-WRAPPER) (X3 NUMBER-WRAPPER)))"
    (CL:FUNCTION /PL-KERNEL-KB/DIVIDE-CONSTRAINT) NULL)
   (DEFINE-FUNCTION-OBJECT "SQRT-CONSTRAINT"
    "(DEFUN (SQRT-CONSTRAINT OBJECT) ((MISSING-ARGUMENT INTEGER-WRAPPER) (X1 NUMBER-WRAPPER) (X2 NUMBER-WRAPPER)))"
    (CL:FUNCTION /PL-KERNEL-KB/SQRT-CONSTRAINT) NULL)
   (DEFINE-FUNCTION-OBJECT "CREATE-INTERVAL-CACHE"
    "(DEFUN (CREATE-INTERVAL-CACHE INTERVAL-CACHE) ((INTERVALMEMBER LOGIC-OBJECT) (INTEGER? BOOLEAN)) :PUBLIC? TRUE)"
    (CL:FUNCTION /PL-KERNEL-KB/CREATE-INTERVAL-CACHE) NULL)
   (DEFINE-FUNCTION-OBJECT "GET-INTERVAL-CACHE"
    "(DEFUN (GET-INTERVAL-CACHE INTERVAL-CACHE) ((SELF LOGIC-OBJECT)) :PUBLIC? TRUE)"
    (CL:FUNCTION /PL-KERNEL-KB/GET-INTERVAL-CACHE) NULL)
   (DEFINE-FUNCTION-OBJECT "COERCE-INTERVAL-BOUND-TO-INTEGER"
    "(DEFUN (COERCE-INTERVAL-BOUND-TO-INTEGER INTEGER) ((SELF NUMBER-WRAPPER) (OPERATOR SURROGATE)) :PUBLIC? TRUE)"
    (CL:FUNCTION /PL-KERNEL-KB/COERCE-INTERVAL-BOUND-TO-INTEGER) NULL)
   (DEFINE-FUNCTION-OBJECT "INTEGER.COERCE-INTERVAL-BOUND-TO-INTEGER"
    "(DEFUN (INTEGER.COERCE-INTERVAL-BOUND-TO-INTEGER INTEGER) ((SELF INTEGER-WRAPPER) (OPERATOR SURROGATE)))"
    (CL:FUNCTION /PL-KERNEL-KB/INTEGER.COERCE-INTERVAL-BOUND-TO-INTEGER)
    NULL)
   (DEFINE-FUNCTION-OBJECT "FLOAT.COERCE-INTERVAL-BOUND-TO-INTEGER"
    "(DEFUN (FLOAT.COERCE-INTERVAL-BOUND-TO-INTEGER INTEGER) ((SELF FLOAT-WRAPPER) (OPERATOR SURROGATE)))"
    (CL:FUNCTION /PL-KERNEL-KB/FLOAT.COERCE-INTERVAL-BOUND-TO-INTEGER)
    NULL)
   (DEFINE-FUNCTION-OBJECT "SIGNAL-INTERVAL-CLASH"
    "(DEFUN SIGNAL-INTERVAL-CLASH ((INTERVAL INTERVAL-CACHE)))"
    (CL:FUNCTION /PL-KERNEL-KB/SIGNAL-INTERVAL-CLASH) NULL)
   (DEFINE-FUNCTION-OBJECT "EVALUATE-ADJACENT-INEQUALITIES"
    "(DEFUN EVALUATE-ADJACENT-INEQUALITIES ((SELF LOGIC-OBJECT)))"
    (CL:FUNCTION /PL-KERNEL-KB/EVALUATE-ADJACENT-INEQUALITIES) NULL)
   (DEFINE-METHOD-OBJECT
    "(DEFMETHOD EVALUATE-TIGHTER-INTERVAL ((INTERVAL INTERVAL-CACHE)))"
    (CL:FUNCTION /PL-KERNEL-KB/EVALUATE-TIGHTER-INTERVAL) NULL)
   (DEFINE-METHOD-OBJECT
    "(DEFMETHOD EVALUATE-TIGHTER-INTERVAL ((INTERVAL INTEGER-INTERVAL-CACHE)))"
    (CL:FUNCTION /PL-KERNEL-KB/EVALUATE-TIGHTER-INTERVAL) NULL)
   (DEFINE-METHOD-OBJECT
    "(DEFMETHOD EVALUATE-TIGHTER-INTERVAL ((INTERVAL FLOAT-INTERVAL-CACHE)))"
    (CL:FUNCTION /PL-KERNEL-KB/EVALUATE-TIGHTER-INTERVAL) NULL)
   (DEFINE-METHOD-OBJECT
    "(DEFMETHOD PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE ((SELF INTERVAL-CACHE) (VALUE NUMBER-WRAPPER) (OPERATOR SURROGATE)))"
    (CL:FUNCTION /PL-KERNEL-KB/PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE)
    NULL)
   (DEFINE-METHOD-OBJECT
    "(DEFMETHOD PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE ((SELF INTEGER-INTERVAL-CACHE) (VALUE NUMBER-WRAPPER) (OPERATOR SURROGATE)))"
    (CL:FUNCTION /PL-KERNEL-KB/PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE)
    NULL)
   (DEFINE-METHOD-OBJECT
    "(DEFMETHOD PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE ((SELF FLOAT-INTERVAL-CACHE) (VALUE NUMBER-WRAPPER) (OPERATOR SURROGATE)))"
    (CL:FUNCTION /PL-KERNEL-KB/PROPAGATE-INEQUALITY-TO-INTERVAL-CACHE)
    NULL)
   (DEFINE-FUNCTION-OBJECT "INVERSE-INEQUALITY-OPERATOR"
    "(DEFUN (INVERSE-INEQUALITY-OPERATOR SURROGATE) ((OPERATOR SURROGATE)))"
    (CL:FUNCTION /PL-KERNEL-KB/INVERSE-INEQUALITY-OPERATOR) NULL)
   (DEFINE-FUNCTION-OBJECT "UNIFY-INTERVAL-CACHES"
    "(DEFUN UNIFY-INTERVAL-CACHES ((CACHE1 INTERVAL-CACHE) (CACHE2 INTERVAL-CACHE) (OPERATOR SURROGATE)))"
    (CL:FUNCTION /PL-KERNEL-KB/UNIFY-INTERVAL-CACHES) NULL)
   (DEFINE-FUNCTION-OBJECT "ACCESS-INTERVAL-BOUNDS"
    "(DEFUN (ACCESS-INTERVAL-BOUNDS NUMBER-WRAPPER BOOLEAN) ((X OBJECT) (LOWERORUPPER KEYWORD)))"
    (CL:FUNCTION /PL-KERNEL-KB/ACCESS-INTERVAL-BOUNDS) NULL)
   (DEFINE-FUNCTION-OBJECT "ACCESS-INTERVAL-CACHE-BOUNDS"
    "(DEFUN (ACCESS-INTERVAL-CACHE-BOUNDS NUMBER-WRAPPER BOOLEAN) ((INTERVALCACHE INTERVAL-CACHE) (LOWERORUPPER KEYWORD)))"
    (CL:FUNCTION /PL-KERNEL-KB/ACCESS-INTERVAL-CACHE-BOUNDS) NULL)
   (DEFINE-FUNCTION-OBJECT "COMPARE-INTERVAL-BOUNDS?"
    "(DEFUN (COMPARE-INTERVAL-BOUNDS? BOOLEAN) ((RELATION SURROGATE) (X NUMBER-WRAPPER) (Y NUMBER-WRAPPER)))"
    (CL:FUNCTION /PL-KERNEL-KB/COMPARE-INTERVAL-BOUNDS?) NULL)
   (DEFINE-FUNCTION-OBJECT "NULL-NUMBER?"
    "(DEFUN (NULL-NUMBER? BOOLEAN) ((SELF NUMBER-WRAPPER)) :PUBLIC? TRUE)"
    (CL:FUNCTION /PL-KERNEL-KB/NULL-NUMBER?) NULL)
   (DEFINE-FUNCTION-OBJECT "LESS-SPECIALIST"
    "(DEFUN (LESS-SPECIALIST KEYWORD) ((FRAME CONTROL-FRAME) (LASTMOVE KEYWORD)))"
    (CL:FUNCTION /PL-KERNEL-KB/LESS-SPECIALIST) NULL)
   (DEFINE-FUNCTION-OBJECT "GREATER-SPECIALIST"
    "(DEFUN (GREATER-SPECIALIST KEYWORD) ((FRAME CONTROL-FRAME) (LASTMOVE KEYWORD)))"
    (CL:FUNCTION /PL-KERNEL-KB/GREATER-SPECIALIST) NULL)
   (DEFINE-FUNCTION-OBJECT "INEQUALITY-EVALUATOR"
    "(DEFUN INEQUALITY-EVALUATOR ((SELF PROPOSITION)))"
    (CL:FUNCTION /PL-KERNEL-KB/INEQUALITY-EVALUATOR) NULL)
   (DEFINE-FUNCTION-OBJECT "LENGTH-COMPUTATION"
    "(DEFUN (LENGTH-COMPUTATION INTEGER-WRAPPER) ((X OBJECT)))"
    (CL:FUNCTION /PL-KERNEL-KB/LENGTH-COMPUTATION) NULL)
   (DEFINE-FUNCTION-OBJECT "STARTUP-ARITHMETIC"
    "(DEFUN STARTUP-ARITHMETIC () :PUBLIC? TRUE)"
    (CL:FUNCTION /PL-KERNEL-KB/STARTUP-ARITHMETIC) NULL)
   (CL:LET*
    ((FUNCTION
      (LOOKUP-FUNCTION
       /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-STARTUP-ARITHMETIC)))
    (SET-DYNAMIC-SLOT-VALUE (%DYNAMIC-SLOTS FUNCTION)
     /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-METHOD-STARTUP-CLASSNAME
     (WRAP-STRING "Startup-Arithmetic") NULL-STRING-WRAPPER))))

(CL:DEFUN /PL-KERNEL-KB/STARTUP-ARITHMETIC ()
  (CL:LET*
   ((*MODULE*
     (GET-STELLA-MODULE "/PL-KERNEL-KB" (> *STARTUP-TIME-PHASE* 1)))
    (*CONTEXT* *MODULE*))
   (CL:DECLARE (CL:SPECIAL *MODULE* *CONTEXT*))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 2)
    (/PL-KERNEL-KB/HELP-STARTUP-ARITHMETIC1)
    (/PL-KERNEL-KB/HELP-STARTUP-ARITHMETIC2))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 5)
    (CL:LET*
     ((CLASS
       (DEFINE-CLASS-FROM-STRINGIFIED-SOURCE "INTERVAL-CACHE"
        "(DEFCLASS INTERVAL-CACHE (THING) :PUBLIC? TRUE :PUBLIC-SLOTS ((HOME-CONTEXT :TYPE CONTEXT) (INTERVAL-MEMBER :TYPE LOGIC-OBJECT)))")))
     (CL:SETF (%CLASS-CONSTRUCTOR-CODE CLASS)
      (CL:FUNCTION /PL-KERNEL-KB/NEW-INTERVAL-CACHE))
     (CL:SETF (%CLASS-SLOT-ACCESSOR-CODE CLASS)
      (CL:FUNCTION /PL-KERNEL-KB/ACCESS-INTERVAL-CACHE-SLOT-VALUE)))
    (CL:LET*
     ((CLASS
       (DEFINE-CLASS-FROM-STRINGIFIED-SOURCE "INTEGER-INTERVAL-CACHE"
        "(DEFCLASS INTEGER-INTERVAL-CACHE (INTERVAL-CACHE) :PUBLIC? TRUE :PUBLIC-SLOTS ((LOWER-BOUND :TYPE INTEGER) (UPPER-BOUND :TYPE INTEGER)) :PRINT-FORM (PRINT-NATIVE-STREAM STREAM \"|IIcache-of: \" (INTERVAL-MEMBER SELF) \" [\" (CHOOSE (DEFINED? (LOWER-BOUND SELF)) (INTEGER-TO-STRING (LOWER-BOUND SELF)) \"?\") \",\" (CHOOSE (DEFINED? (UPPER-BOUND SELF)) (INTEGER-TO-STRING (UPPER-BOUND SELF)) \"?\") \"]|\"))")))
     (CL:SETF (%CLASS-CONSTRUCTOR-CODE CLASS)
      (CL:FUNCTION /PL-KERNEL-KB/NEW-INTEGER-INTERVAL-CACHE))
     (CL:SETF (%CLASS-SLOT-ACCESSOR-CODE CLASS)
      (CL:FUNCTION
       /PL-KERNEL-KB/ACCESS-INTEGER-INTERVAL-CACHE-SLOT-VALUE)))
    (CL:LET*
     ((CLASS
       (DEFINE-CLASS-FROM-STRINGIFIED-SOURCE "FLOAT-INTERVAL-CACHE"
        "(DEFCLASS FLOAT-INTERVAL-CACHE (INTERVAL-CACHE) :PUBLIC? TRUE :PUBLIC-SLOTS ((LOWER-BOUND :TYPE FLOAT) (UPPER-BOUND :TYPE FLOAT) (STRICT-LOWER-BOUND? :TYPE BOOLEAN) (STRICT-UPPER-BOUND? :TYPE BOOLEAN)) :PRINT-FORM (PRINT-NATIVE-STREAM STREAM \"|FIcache-of: \" (INTERVAL-MEMBER SELF) \" \" (CHOOSE (STRICT-LOWER-BOUND? SELF) \"(\" \"[\") (CHOOSE (DEFINED? (LOWER-BOUND SELF)) (FLOAT-TO-STRING (LOWER-BOUND SELF)) \"?\") \",\" (CHOOSE (DEFINED? (UPPER-BOUND SELF)) (FLOAT-TO-STRING (UPPER-BOUND SELF)) \"?\") (CHOOSE (STRICT-UPPER-BOUND? SELF) \")\" \"]\") \"|\"))")))
     (CL:SETF (%CLASS-CONSTRUCTOR-CODE CLASS)
      (CL:FUNCTION /PL-KERNEL-KB/NEW-FLOAT-INTERVAL-CACHE))
     (CL:SETF (%CLASS-SLOT-ACCESSOR-CODE CLASS)
      (CL:FUNCTION
       /PL-KERNEL-KB/ACCESS-FLOAT-INTERVAL-CACHE-SLOT-VALUE))))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 6) (FINALIZE-CLASSES))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 7)
    (/PL-KERNEL-KB/HELP-STARTUP-ARITHMETIC3))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 8) (FINALIZE-SLOTS)
    (CLEANUP-UNFINALIZED-CLASSES))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 9)
    (%DEFFUNCTION
     (CONS-LIST /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-PLUS
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-->
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z
       /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-DOCUMENTATION
      (WRAP-STRING "Function that adds two numbers.")
      /PL-KERNEL-KB/KWD-ARITHMETIC-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-COMPUTED
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-PLUS NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-CONSTRAINT
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-PLUS
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-PLUS-CONSTRAINT NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-SPECIALIST
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-PLUS
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-CONSTRAINT-SPECIALIST
        NIL)
       NIL)))
    (%DEFFUNCTION
     (CONS-LIST /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-MINUS
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-->
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z
       /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-DOCUMENTATION
      (WRAP-STRING "Function that adds two numbers.")
      /PL-KERNEL-KB/KWD-ARITHMETIC-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-COMPUTED
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-MINUS NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-CONSTRAINT
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-MINUS
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-MINUS-CONSTRAINT NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-SPECIALIST
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-MINUS
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-CONSTRAINT-SPECIALIST
        NIL)
       NIL)))
    (%DEFFUNCTION
     (CONS-LIST /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-TIMES
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-->
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z
       /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-DOCUMENTATION
      (WRAP-STRING "Function that adds two numbers.")
      /PL-KERNEL-KB/KWD-ARITHMETIC-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-COMPUTED
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-TIMES NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-CONSTRAINT
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-TIMES
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-TIMES-CONSTRAINT NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-SPECIALIST
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-TIMES
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-CONSTRAINT-SPECIALIST
        NIL)
       NIL)))
    (%DEFFUNCTION
     (CONS-LIST /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-DIVIDE
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-->
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z
       /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-DOCUMENTATION
      (WRAP-STRING "Function that adds two numbers.")
      /PL-KERNEL-KB/KWD-ARITHMETIC-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-COMPUTED
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-DIVIDE NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-CONSTRAINT
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-DIVIDE
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-DIVIDE-CONSTRAINT NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-SPECIALIST
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-DIVIDE
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-CONSTRAINT-SPECIALIST
        NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SQUARE-ROOT
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-DOCUMENTATION
      (WRAP-STRING
       "Relation that returns the positive and negative square roots:
?y = sqrt(?x).")
      /PL-KERNEL-KB/KWD-ARITHMETIC-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-COMPUTED
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SQUARE-ROOT NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-SPECIALIST
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SQUARE-ROOT
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SQUARE-ROOT-SPECIALIST
        NIL)
       NIL)))
    (%ASSERT
     (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND
      (LIST*
       /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-HANDLES-REVERSE-POLARITY
       /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-SPECIALIST NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-HANDLES-REVERSE-POLARITY
       /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-SPECIALIST NIL)
      NIL))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INEQUALITY
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-DOCUMENTATION
      (WRAP-STRING "Abstract superrelation of inequality relations.")
      /PL-KERNEL-KB/KWD-ARITHMETIC-<<=
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL
       /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
       /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-<<=
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL
       /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
       /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-ABSTRACT
       /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INEQUALITY NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-THAN
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-DOCUMENTATION
      (WRAP-STRING "True if ?x < ?y.") /PL-KERNEL-KB/KWD-ARITHMETIC-<<=
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-EXISTS
       /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND
        (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-THAN
         /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
         /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z NIL)
        (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL
         /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z
         /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y NIL)
        NIL)
       NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-<<=
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-EXISTS
       /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND
        (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL
         /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
         /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z NIL)
        (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-THAN
         /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z
         /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y NIL)
        NIL)
       NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-COMPUTED
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-THAN NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-SPECIALIST
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-THAN
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-SPECIALIST NIL)
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-EVALUATOR
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-THAN
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INEQUALITY-EVALUATOR
        NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-DOCUMENTATION
      (WRAP-STRING "True if ?x <= ?y.") /PL-KERNEL-KB/KWD-ARITHMETIC-<<=
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-EXISTS
       /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND
        (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL
         /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
         /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z NIL)
        (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL
         /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z
         /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y NIL)
        NIL)
       NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-<<=
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-THAN
       /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
       /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-COMPUTED
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-SPECIALIST
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-SPECIALIST NIL)
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-EVALUATOR
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INEQUALITY-EVALUATOR
        NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-DOCUMENTATION
      (WRAP-STRING "True if ?x > ?y.") /PL-KERNEL-KB/KWD-ARITHMETIC-<<=>>
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-THAN
       /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y
       /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-COMPUTED
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-SPECIALIST
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-SPECIALIST NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-DOCUMENTATION
      (WRAP-STRING "True if ?x >= ?y.") /PL-KERNEL-KB/KWD-ARITHMETIC-<<=>>
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL
       /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y
       /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-<<=
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN
       /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
       /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Y NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-COMPUTED
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-SPECIALIST
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-SPECIALIST NIL)
       NIL)))
    (%ASSERT
     (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SYNONYM
      /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-PLUS
      /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-+ NIL))
    (%ASSERT
     (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SYNONYM
      /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-MINUS
      /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-= NIL))
    (%ASSERT
     (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SYNONYM
      /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-TIMES
      /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-* NIL))
    (%ASSERT
     (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SYNONYM
      /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-THAN
      /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-< NIL))
    (%ASSERT
     (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SYNONYM
      /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LESS-OR-EQUAL
      /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-=< NIL))
    (%ASSERT
     (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SYNONYM
      /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-THAN
      /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-> NIL))
    (%ASSERT
     (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-SYNONYM
      /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-GREATER-OR-EQUAL
      /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA->= NIL))
    (%DEFFUNCTION
     (CONS-LIST
      /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INTERVAL-CACHE-OF
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-NUMBER NIL)
       NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-->
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-?B
       /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INTERVAL-CACHE NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-DOCUMENTATION
      (WRAP-STRING "Binds an instance ?x of type NUMBER to a structure that
records its tightest lower and upper bounds.")
      /PL-KERNEL-KB/KWD-ARITHMETIC-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-HIDDEN-RELATION
       /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-INTERVAL-CACHE-OF NIL)))
    (%DEFFUNCTION
     (CONS-LIST /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-LENGTH
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?X
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-THING NIL)
       NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-->
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-LOGIC-?Z
       /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-INTEGER NIL)
      /PL-KERNEL-KB/KWD-ARITHMETIC-DOCUMENTATION
      (WRAP-STRING "Function that returns the length of a string
or a logical list.")
      /PL-KERNEL-KB/KWD-ARITHMETIC-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-COMPUTED
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-LENGTH NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-COMPUTATION
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-LENGTH
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-LENGTH-COMPUTATION NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-RELATION-SPECIALIST
        /PL-KERNEL-KB/SYM-ARITHMETIC-STELLA-LENGTH
        /PL-KERNEL-KB/SYM-ARITHMETIC-PL-KERNEL-KB-COMPUTATION-SPECIALIST
        NIL)
       NIL))))))
